# RH 2.2.4-20, SuSE 2.3.1-32
%define name		%{cross_prefix}glibc

# <epoch>:<version>-<release> tags for glibc main package
%define glibcversion	2.12.1
%define __glibcrelease	11
%define glibcepoch	6

# use for updates
%define subrel		3

# CVS snapshots of glibc
%define RELEASE		1
%if %{RELEASE}
%define source_package	glibc-%{glibcversion}
%define source_dir	glibc-%{glibcversion}
%define _glibcrelease	%{__glibcrelease}
%define portsversion	%{glibcversion}
%else
%define snapshot	20081113
%define source_package	glibc-%{glibcversion}-%{snapshot}
%define source_dir	glibc-%{glibcversion}
%define _glibcrelease	0.%{snapshot}.%{__glibcrelease}
%define portsversion	2.9
%endif

%define glibcrelease	%mkrel %{_glibcrelease}

# crypt blowfish support
%define crypt_bf_ver	1.1

# Define "cross" to an architecture to which glibc is to be
# cross-compiled
%define build_cross		0
%{expand: %{?cross:		%%global build_cross 1}}

%if %{build_cross}
%define target_cpu	%{cross}
%define cross_prefix	cross-%{target_cpu}-
%define _prefix		/usr/%{target_cpu}-%{_real_vendor}-linux%{gnuext}
%define cross_program_prefix	%{target_cpu}-%{_real_vendor}-linux%{gnuext}-
%define _exec_prefix	%{_prefix}
# brain damage alert: should not be needed imho
# overriding _prefix and _exec_prefix should be enough
%define _bindir		%{_exec_prefix}/bin
%define _sbindir	%{_exec_prefix}/sbin
%define _libexecdir	%{_exec_prefix}/libexec
%define _datadir	%{_prefix}/share
%define _sharedstatedir	%{_prefix}/com
%define _localstatedir	%{_prefix}/var
%define _lib		lib
%define _libdir		%{_exec_prefix}/%{_lib}
%define _slibdir	%{_exec_prefix}/%{_lib}
%define _slibdir32	%{_exec_prefix}/lib
%define _includedir	%{_prefix}/include
%else
%define gnuext		%{_gnu}
%define target_cpu	%{_target_cpu}
%define cross_prefix	%{nil}
%define cross_program_prefix	%{nil}
%define _slibdir	/%{_lib}
%define _slibdir32	/lib
%endif

# Define target (base) architecture
%define arch		%(echo %{target_cpu}|sed -e "s/\\(i.86\\|athlon\\)/i386/" -e "s/amd64/x86_64/" -e "s/\\(sun4.*\\|sparcv[89]\\)/sparc/")
%define isarch()	%(case " %* " in (*" %{arch} "*) echo 1;; (*) echo 0;; esac)

%if %{build_cross}
%if %isarch %arm
%define gnuext          -gnueabi
%else
%define gnuext          -gnu
%endif
%endif

# Define Xen arches to build with -mno-tls-direct-direct-seg-refs
%define xenarches	%{ix86} x86_64

# arches which requires glibc-port
%define ports_arch	%arm %mips

# Define to build nscd with selinux support
%define build_selinux	0

# Flag for build_pdf_doc:
# 1	build glibc with PDF documentation
# 0	don't build PDF glibc documentation (e.g. for bootstrap build)
%define build_pdf_doc	1

# Enable checking by default for arches where we know tests all pass
%define build_check	1

# Allow make check to fail only when running kernels where we know
# tests must pass (no missing features or bugs in the kernel)
%define check_min_kver 2.6.21

# Define to build a biarch package
%define build_biarch	0
%if %isarch sparc64 x86_64 ppc64 mips64 mips64el
%define build_biarch	1
%endif

# Define to build glibc-debug package
%define build_debug	1
%define _enable_debug_packages 1
%if "%{_enable_debug_packages}" == "1"
%define build_debug	0
%endif

# Define to bootstrap new glibc
%define build_bootstrap	0
%{expand: %{!?build_cross_bootstrap: %global build_cross_bootstrap 0}}

%define build_profile	1
%define build_nscd	1
%define build_doc	1
%define build_utils	1
%define build_i18ndata	1
%define build_timezone	0

# Disable a few defaults when cross-compiling a glibc
%if %{build_cross}
%define build_doc	0
%define build_pdf_doc	0
%define build_biarch	0
%define build_check	0
%define build_debug	0
%define build_nscd	0
%define build_profile	0
%define build_utils	0
%define build_i18ndata	0
%define build_timezone	0
%endif

# Allow --with[out] <feature> at rpm command line build
%{expand: %{?_without_PDF:	%%global build_pdf_doc 0}}
%{expand: %{?_without_CHECK:	%%global build_check 0}}
%{expand: %{?_without_UTILS:	%%global build_utils 0}}
%{expand: %{?_without_BOOTSTRAP:%%global build_bootstrap 0}}
%{expand: %{?_with_PDF:		%%global build_pdf_doc 1}}
%{expand: %{?_with_CHECK:	%%global build_check 1}}
%{expand: %{?_with_UTILS:	%%global build_utils 1}}
%{expand: %{?_with_BOOTSTRAP:	%%global build_bootstrap 1}}

Summary:	The GNU libc libraries
Name:		%{name}
Version:	%{glibcversion}
Release:	%{glibcrelease}
Epoch:		%{glibcepoch}
License:	LGPL
Group:		System/Libraries
Url:		http://www.gnu.org/software/libc/

# FSF source
Source0:	http://ftp.gnu.org/gnu/glibc/%{source_package}.tar.xz
%if %{RELEASE}
Source1:	http://ftp.gnu.org/gnu/glibc/%{source_package}.tar.xz.sig
%endif

# Red Hat tarball
Source2:	glibc-redhat.tar.bz2
Source3:	glibc-manpages.tar.bz2
Source4:	glibc-find-requires.sh
Source5:	glibc-check.sh

# wrapper to avoid rpm circular dependencies
Source14:	glibc-post-wrapper.c

# <http://penguinppc.org/dev/glibc/glibc-powerpc-cpu-addon.html>
# NOTE: this check is weak. The rationale is: Cell PPU optimized by
# default
%define powerpc_cpu_list noarch
Source15:	glibc-powerpc-cpu-addon-v0.03.tar.bz2

# Blowfish support
Source16:	crypt_blowfish-%{crypt_bf_ver}.tar.gz
Source17:	crypt_freesec.c
Source18:	crypt_freesec.h

# tarball are at http://ftp.gnu.org/gnu/glibc/
# for snapshots :
# git clone git://sources.redhat.com/git/glibc-ports.git
# git archive --format=tar --prefix=glibc-ports-2.9/ HEAD | bzip2 -c > ../glibc-ports-2.9-$(date +%%Y%%m%%d).tar.bz2
Source20:	glibc-ports-%{portsversion}.tar.bz2

Buildroot:	%{_tmppath}/glibc-%{PACKAGE_VERSION}-root
%if %{build_cross}
Autoreq:	false
Autoprov:	false
%else
Provides:	glibc-crypt_blowfish = %{crypt_bf_ver}
Provides:	should-restart = system
%if %isarch %{xenarches}
Obsoletes:	%{name}-xen
Provides:	%{name}-xen
%endif
# The dynamic linker supports DT_GNU_HASH
Provides: rtld(GNU_HASH)
Autoreq:	false
%endif
BuildRequires:	patch, gettext, perl
BuildRequires:	linux-userspace-headers
%if %{build_selinux}
BuildRequires:	libselinux-devel >= 1.17.10
%endif
# need linker for -Wl,--hash-style=both (>= 2.16.91.0.7-6})
# need gnu indirect function for multiarch (>= 2.19.51.0.14-1)
%define binutils_version 2.19.51.0.14-1
BuildRequires:	%{cross_prefix}binutils >= %{binutils_version}
# we need the static dash
%define ash_bin		/bin/dash.static
Requires(pre):		dash-static
Requires(post):		dash-static
# we need an ldconfig with TLS support
%if %{build_cross}
BuildRequires:	%{cross_prefix}gcc >= 3.2.2-4
%endif
%ifarch %{ix86} alpha
BuildRequires:	%{cross_prefix}gcc >= 2.96-0.50
%endif
%ifarch ia64
BuildRequires:	%{cross_prefix}gcc >= 3.2.3-1
%endif
%ifarch x86_64
BuildRequires:	%{cross_prefix}gcc >= 3.1.1-0.5
%endif
BuildRequires:	%{cross_prefix}gcc >= 4.0.1-2
%if !%{build_cross}
%ifarch alpha
Provides:	ld.so.2
%endif
%ifarch ppc mips mipsel
Provides:	ld.so.1
%endif
%ifarch sparc
Obsoletes:	libc
%endif
%endif

# Old prelink versions brakes the system with glibc 2.11
Conflicts:	prelink < 1:0.4.2-1.20091104.1

BuildRequires:	texinfo
%if %{build_pdf_doc}
BuildRequires:	tetex, tetex-latex
%endif
%if %{build_utils}
BuildRequires:	gd-devel
%endif
BuildRequires:	autoconf2.5
BuildRequires:	libcap-devel
BuildRequires:	rpm-mageia-setup-build >= 1.104
BuildRequires:	spec-helper >= 0.31.2

# make "localedef --add-to-archive" to follow symlink
# safe to send ustream, need to be kept for locales
Patch00:	glibc-2.11.1-localedef-archive-follow-symlinks.patch

# various path fix, for _PATH_VI and _PATH_VARDB
Patch01:	glibc-2.12.1-fhs.patch
Patch02:	glibc-2.9-ldd-non-exec.patch
Patch03:	glibc-2.11-bz10851.patch
# try to fallback on loading /lib/libnss_*.so.X.Y when the loading 
# of /lib/libnss_*.so.X failed. Should be dropped, IMHO.
Patch04:	glibc-2.2-nss-upgrade.patch

# patch from https://qa.mandriva.com/show_bug.cgi?id=58834
# deferred upstream until rfc is changed, no need to push upstream
Patch05:	glibc-2.12.1-assign-global-scope-to-RFC-1918-addresses.patch
Patch06:	glibc-2.9-share-locale.patch

# default nsswitch.conf
# should be moved out patch and be a regular Source
Patch07:	glibc-2.3.6-nsswitch.conf.patch
Patch08:	glibc-2.12.1-make-3.82-fix.patch

# use xvt instead of xterm in xtrace.sh
# cannot be pushed upstream as xvt is Ma* specific 
Patch09:	glibc-2.2.4-xterm-xvt.patch

# add transliteration for "COLON SIGN"
# ( used for the money of money of san salvador )
Patch10:	glibc-2.12.1-submitted-translit-colon.patch
Patch11:	glibc-2.4.90-compat-EUR-currencies.patch
Patch12:	glibc-2.3.6-ppc-build-lddlibc4.patch

# fix the chkconfig header, should be sent upstream
Patch13:	glibc-2.3.3-nscd-enable.patch

# disable cache for hosts on nscd, as this is seen as insecure
# if the system relie on reverse dns for security
Patch14:	glibc-2.9-nscd-no-host-cache.patch


Patch15:	glibc-2.12.1-ldconfig-chroot-aux-cache.patch
Patch16:	glibc-2.12.1-workaround-shortest-stem-in-make-3.82.patch
Patch17:	glibc-2.4.90-i386-hwcapinfo.patch
Patch18:	glibc-2.7-provide_CFI_for_the_outermost_function.patch

# another fix for nscd init script, make it start after network, ldap, mysql and ypbind
# should be sent upstream
Patch19:	glibc-2.8-nscd-init-should-start.patch
Patch20:	glibc-2.12.1-never-expand-ORIGIN-in-privileged-programs.patch

# according to the patch : "The Linux kernel has a bug which silently ignore the invalid
#    c_cflag on pty.". Patch is likely fixed in kernel, but this should be checked
Patch22:	glibc-2.3.2-tcsetattr-kernel-bug-workaround.patch

# add some new timezone for various cities
# Halifax, Montreal, Johannesburg 
# should be sent upstream ( I guess )
Patch23:	glibc-2.3.4-timezone.patch
Patch24:	glibc-2.10.1-biarch-cpp-defines.patch
Patch26:	glibc-2.6-nice_fix.patch

# fix a typo, safe to send upstream
Patch27:	glibc-2.8-ENOTTY-fr-translation.patch
Patch28:	glibc-2.4.90-gcc4-fortify.patch
Patch29:	glibc-2.3.5-biarch-utils.patch

# remove multiarch header, Ma* specific patch
# check if still needed or if the work was finished
Patch30:	glibc-2.10.1-multiarch.patch
Patch31:	glibc-2.4.90-i586-hptiming.patch

# do not use i686 optimised library if the processor do not support
# cmov ( some i686 cpu don't, from VIA iirc )
# shuld be sent upstream, IMHO
Patch32:	glibc-2.3.4-i586-if-no-cmov.patch

# translation fixes, need to be checked with some i18n team member
# should be safe to send upstream once checked
Patch33:	glibc-2.3.6-pt_BR-i18nfixes.patch
Patch34:	glibc-2.4.90-testsuite-ldbl-bits.patch
Patch35:	glibc-2.12.1-fix-error-handling-in-Linux-getlogin.patch
Patch36:	glibc-2.12.1-more-fixes-to-error-handling-in-getlogin_r.patch
Patch37:	glibc-2.12.1-__getlogin_r_loginuid-fail-if-tpwd-after-pwuid-is-NULL.patch

# disable parralel testsuite of rt on powerpc with SMT 
Patch38:	glibc-2.4.90-testsuite-rt-notparallel.patch
Patch39:	glibc-2.10.1-mdv-owl-crypt_freesec.patch
Patch40:	glibc-2.9-avx-relocate_fcrypt.patch
Patch41:	glibc-2.3.6-avx-increase_BF_FRAME.patch
Patch42:	glibc-2.10.1-mdv-avx-owl-crypt.patch

# add support for sha256 and sha512 in crypt
# likely coming from owl
Patch43:	glibc-2.7-mdv-wrapper_handle_sha.patch

# check for libcap, even if selinux is disabled
# should be sent upstream
Patch44:	glibc-2.11-dont-tie-libcap-with-selinux.patch
Patch45:	glibc-2.12.1-CVE-2010-3856.diff
# change page size to 16k. mandatory for loongson
# but not necessary a good idea for other socs
Patch46:	glibc_mips_16k_page_size.patch
# shamlessly taken in linaro. just look dirty woraround
Patch47:	glibc_local-syscall-mcount.diff

# fixes from upstream 2.12.2
# fix java apps crashing on x86_64 (mga #1362)
Patch48:	glibc-2.12.1-fix-alignment-of-AVX-safe-area-on-x86-64-bz12113.patch
Patch49:	glibc-2.12.1-fix-handling-of-tail-bytes-of-buffer-in-SSE2-SSSE3-x86-64-version-strncmp-bz12077.patch

# grabbed from opensuse to fix mga #2526
# (tmb) disable for now as it introduced regression
# see: https://bugs.mageia.org/show_bug.cgi?id=1362#c14
#Patch50:	glibc-elf-localscope.diff

# CVE fixes
Patch51:	glibc-2.12.1-Report-write-error-in-addmnt-even-for-cached-streams_CVE-2011-1089.patch
Patch52:	glibc-2.11.1-CVE-2011-1071.diff
Patch53:	glibc-2.11.1-CVE-2011-1095.diff
Patch54:	glibc-2.11.1-CVE-2011-1659.diff

# Determine minium kernel versions
%define		enablekernel 2.6.9
%if %isarch ppc ppc64
# waitid syscall is available in 2.6.12+ there
%define		enablekernel 2.6.12
%endif
Conflicts:	kernel < %{enablekernel}

# People changed location of rpm scripts...
%define rpmscripts	/usr/lib/rpm/%{_real_vendor}

# Don't try to explicitly provide GLIBC_PRIVATE versioned libraries
%define __find_provides	%{_builddir}/%{source_dir}/find_provides.sh
%define __find_requires %{_builddir}/%{source_dir}/find_requires.sh

%if !%{build_cross}
Obsoletes:	ld.so
Provides:	ld.so
%endif

Obsoletes:	ldconfig
Provides:	ldconfig = %{glibcepoch}:%{glibcversion}-%{glibcrelease} /sbin/ldconfig

%description
The glibc package contains standard libraries which are used by
multiple programs on the system. In order to save disk space and
memory, as well as to make upgrading easier, common system code is
kept in one place and shared between programs. This particular package
contains the most important sets of shared libraries: the standard C
library and the standard math library. Without these two libraries, a
Linux system will not function.  The glibc package also contains
national language (locale) support.

This package now also provides ldconfig which was package seperately in
the past. Ldconfig is a basic system program which determines run-time
link bindings between ld.so and shared libraries. Ldconfig scans a running
system and sets up the symbolic links that are used to load shared
libraries properly. It also creates a cache (/etc/ld.so.cache) which
speeds the loading of programs which use shared libraries.

%package devel
Summary:	Header and object files for development using standard C libraries
Group:		Development/C
Requires(post):	  info-install
Requires(preun):  info-install
Requires(post):   coreutils
Requires(postun): coreutils, awk
Obsoletes:	libc-debug, libc-headers, libc-devel, linuxthreads-devel, nptl-devel
%if !%{build_debug}
Obsoletes:	%{name}-debug < 6:2.3.2-15
%endif
Requires:	%{name} = %{glibcepoch}:%{glibcversion}-%{glibcrelease}
%if !%{build_cross}
Requires:	linux-userspace-headers
%endif
%if !%isarch ppc
Conflicts:	%{cross_prefix}gcc < 2.96-0.50
%endif
# needs a gcc4 fortify capable compiler
Conflicts:	gcc4.0 < 4.0.1-2
%if %{build_cross}
Autoreq:	false
Autoprov:	false
%else
Autoreq:	true
%endif
Provides:	glibc-crypt_blowfish-devel = %{crypt_bf_ver}

%description devel
The glibc-devel package contains the header and object files necessary
for developing programs which use the standard C libraries (which are
used by nearly all programs).  If you are developing programs which
will use the standard C libraries, your system needs to have these
standard header and object files available in order to create the
executables.

This package also includes the C header files for the Linux kernel.
The header files define structures and constants that are needed for
building most standard programs. The header files are also needed for
rebuilding the kernel.

Install glibc-devel if you are going to develop programs which will
use the standard C libraries.

%package static-devel
Summary:	Static libraries for GNU C library
Group:		Development/C
Requires:	%{name}-devel = %{glibcepoch}:%{glibcversion}-%{glibcrelease}

%description static-devel
The glibc-static-devel package contains the static libraries necessary
for developing programs which use the standard C libraries. Install
glibc-static-devel if you need to statically link your program or
library.

%package profile
Summary:	The GNU libc libraries, including support for gprof profiling
Group:		Development/C
Obsoletes:	libc-profile
Provides:	libc-profile = %{glibcversion}-%{glibcrelease}
Autoreq:	true

%description profile
The glibc-profile package includes the GNU libc libraries and support
for profiling using the gprof program.  Profiling is analyzing a
program's functions to see how much CPU time they use and determining
which functions are calling other functions during execution.  To use
gprof to profile a program, your program needs to use the GNU libc
libraries included in glibc-profile (instead of the standard GNU libc
libraries included in the glibc package).

If you are going to use the gprof program to profile a program, you'll
need to install the glibc-profile program.

%package -n nscd
Summary:	A Name Service Caching Daemon (nscd)
Group:		System/Servers
Requires(pre):	  rpm-helper
Requires(preun):  rpm-helper
Requires(post):   rpm-helper
Requires(postun): rpm-helper
Autoreq:	true

%description -n nscd
Nscd caches name service lookups and can dramatically improve
performance with NIS+, and may help with DNS as well. Note that you
can't use nscd with 2.0 kernels because of bugs in the kernel-side
thread support. Unfortunately, nscd happens to hit these bugs
particularly hard.

Install nscd if you need a name service lookup caching daemon, and
you're not using a version 2.0 kernel.

%if %{build_debug}
%package	debug
Summary:	Shared standard C libraries with debugging information
Group:		System/Libraries
Requires:	%{name} = %{glibcepoch}:%{glibcversion}-%{glibcrelease}
Autoreq:	false

%description debug
The glibc-debug package contains shared standard C libraries with
debugging information. You need this only if you want to step into C
library routines during debugging.

To use these libraries, you need to add %{_libdir}/debug to your
LD_LIBRARY_PATH variable prior to starting the debugger.
%endif

%package utils
Summary:	Development utilities from GNU C library
Group:		Development/Other
Requires:	%{name} = %{glibcepoch}:%{glibcversion}-%{glibcrelease}

%description utils
The glibc-utils package contains memusage, a memory usage profiler,
mtrace, a memory leak tracer and xtrace, a function call tracer which
can be helpful during program debugging.

If unsure if you need this, don't install this package.

%if %{build_i18ndata}
%package i18ndata
Summary:	Database sources for 'locale'
Group:		System/Libraries

%description i18ndata
This package contains the data needed to build the locale data files
to use the internationalization features of the GNU libc.
%endif

%if %{build_timezone}
%package -n timezone
Summary:	Time zone descriptions
Group:		System/Base

%description -n timezone
These are configuration files that describe possible
time zones.
%endif

%package doc
Summary:	GNU C library documentation
Group:		Development/Other

%description doc
The glibc-doc package contains documentation for the GNU C library in
info format.

%if %{build_pdf_doc}
%package doc-pdf
Summary:	GNU C library documentation
Group:		Development/Other

%description doc-pdf
The glibc-doc-pdf package contains the printable documentation for the
GNU C library in PDF format.
%endif

%prep
%setup -q -n %{source_dir} -a 3 -a 2 -a 15 -a 16

%patch00 -p1 -b .localedef-archive-follow-symlinks
%patch01 -p1 -b .fhs
%patch02 -p1 -b .ldd-non-exec
%patch03 -p1 -b .bz10851
%patch04 -p1 -b .nss-upgrade
%patch05 -p1 -b .assign-global-scope-to-RFC-1918-addresses
%patch06 -p1 -b .share-locale
%patch07 -p1 -b .nsswitch.conf
%patch08 -p1 -b .make-3.82-fix
%patch09 -p1 -b .xterm-xvt
%patch10 -p1 -b .translit-colon
%patch11 -p1 -b .compat-EUR-currencies
%patch12 -p1 -b .ppc-lddlibc4
%patch13 -p1 -b .nscd-enable
%patch14 -p1 -b .nscd-no-host-cache
%patch15 -p1 -b .ldconfig-chroot-aux-cache
%patch16 -p1 -b .workaround-shortest-stem-in-make-3.82
%patch17 -p1 -b .i386-hwcapinfo
%patch18 -p0 -R -b .provide_CFI_for_the_outermost_function
%patch19 -p1 -b .nscd-init-should-start
%patch20 -p1 -b .never-expand-ORIGIN-in-privileged-programs
%patch22 -p1 -b .tcsetattr-kernel-bug-workaround
%patch23 -p1 -b .timezone
%patch24 -p1 -b .biarch-cpp-defines
%patch26 -p1 -b .nice-fix
%patch27 -p1 -b .ENOTTY-fr-translation
%patch28 -p1 -b .gcc4-fortify
%patch29 -p1 -b .biarch-utils
%patch30 -p1 -b .multiarch-check
%patch31 -p1 -b .i586-hptiming
%patch32 -p1 -b .i586-if-no-cmov
%patch33 -p1 -b .pt_BR-i18nfixes
%patch34 -p1 -b .testsuite-ldbl-bits
%patch35 -p1 -b .fix-error-handling-in-Linux-getlogin
%patch36 -p1 -b .more-fixes-to-error-handling-in-getlogin_r
%patch37 -p1 -b .__getlogin_r_loginuid-fail-if-tpwd-after-pwuid-is-NULL
%patch38 -p1 -b .testsuite-rt-notparallel
%patch44 -p1 -b .dont-tie-libcap-with-selinux
%patch45 -p1 -b .CVE-2010-3856
%patch48 -p1 -b .fix-alignment-of-AVX-safe-area-on-x86-64-bz12113
%patch49 -p1 -b .fix-handling-of-tail-bytes-of-buffer-in-SSE2-SSSE3-x86-64-version-strncmp-bz12077
#patch50 -p0 -b .glibc-elf-localscope
%patch51 -p1 -b .Report-write-error-in-addmnt-even-for-cached-streams_CVE-2011-1089
%patch52 -p1 -b .CVE-2011-1071
%patch53 -p0 -b .CVE-2011-1095
%patch54 -p0 -b .CVE-2011-1659

%if %isarch %ports_arch
tar xjf %{SOURCE20}
mv glibc-ports-%{glibcversion} ports
%patch46 -p1 -b .pagesize
%patch47 -p1 -b .mcount
%endif

# copy freesec source
cp %{_sourcedir}/crypt_freesec.[ch] crypt/
echo "Applying crypt_blowfish patch:"
%patch42 -p1 -b .mdv-avx-owl-crypt
#patch -p1 -s < crypt_blowfish-%{crypt_bf_ver}/glibc-2.3.2-crypt.diff
mv crypt/crypt.h crypt/gnu-crypt.h
cp -a crypt_blowfish-%{crypt_bf_ver}/*.[chS] crypt/

## FreeSec support for extended/new-style/BSDI hashes in crypt(3)
%patch39 -p1 -b .mdv-owl-crypt_freesec
%patch40 -p1 -b .avx-relocate_fcrypt
%patch41 -p1 -b .avx-increase_BF_FRAME
# add sha256-crypt and sha512-crypt support to the Openwall wrapper
%patch43 -p0 -b .mdv-wrapper_handle_sha

%if %{build_selinux}
# XXX kludge to build nscd with selinux support as it added -nostdinc
# so /usr/include/selinux is not found
ln -s %{_includedir}/selinux selinux
%endif

find . -type f -size 0 -o -name "*.orig" -exec rm -f {} \;

# (Anssi 03/2008) FIXME: use _provides_exceptions
cat > find_provides.sh << EOF
#!/bin/sh
%{rpmscripts}/find-provides | grep -v GLIBC_PRIVATE
exit 0
EOF
chmod +x find_provides.sh

cat > find_requires.bootstrap.sh << EOF
/bin/sh %{SOURCE4} %{buildroot} %{_target_cpu} | grep -v "\(GLIBC_PRIVATE\|linux-gate\|linux-vdso\)"
exit 0
EOF
chmod +x find_requires.bootstrap.sh

# XXX: use better way later to avoid LD_LIBRARY_PATH issue
cat %{rpmscripts}/find-requires | sed '/.*LD_LIBRARY_PATH.*/d;' > find_requires
chmod +x find_requires
# (Anssi 03/2008) FIXME: use _requires_exceptions
cat > find_requires.noprivate.sh << EOF
%{_builddir}/%{source_dir}/find_requires %{buildroot} %{_target_cpu} | \
	grep -v GLIBC_PRIVATE
exit 0
EOF
chmod +x find_requires.noprivate.sh

# FIXME: fix system rpm find-requires to use the prefix cross version
%if %{build_bootstrap} || "%{_target_cpu}" != "%{target_cpu}"
ln -s find_requires.bootstrap.sh find_requires.sh
%else
ln -s find_requires.noprivate.sh find_requires.sh
%endif

# Remove patch backups from files we ship in glibc packages
rm -f ChangeLog.[^0-9]*
rm -f localedata/locales/{???_??,??_??}.*
rm -f localedata/locales/[a-z_]*.*

%build
# Prepare test matrix in the next function
CheckList=$PWD/Check.list
rm -f $CheckList
touch $CheckList

#
# CompareKver <kernel version>
# function to compare the desired kernel version with running kernel
# version (package releases not taken into account in comparison). The
# function returns:
# -1 = <kernel version> is lesser than current running kernel
#  0 = <kernel version> is equal to the current running kernel
#  1 = <kernel version> is greater than current running kernel
#
function CompareKver() {
  v1=`echo $1 | sed 's/\.\?$/./'`
  v2=`uname -r | sed 's/[^.0-9].*//' | sed 's/\.\?$/./'`
  n=1
  s=0
  while true; do
    c1=`echo "$v1" | cut -d "." -f $n`
    c2=`echo "$v2" | cut -d "." -f $n`
    if [ -z "$c1" -a -z "$c2" ]; then
      break
    elif [ -z "$c1" ]; then
      s=-1
      break
    elif [ -z "$c2" ]; then
      s=1
      break
    elif [ "$c1" -gt "$c2" ]; then
      s=1
      break
    elif [ "$c2" -gt "$c1" ]; then
      s=-1
      break
    fi
    n=$((n + 1))
  done
  echo $s
}

#
# BuildGlibc <arch> [<extra_configure_options>+]
#
function BuildGlibc() {
  arch="$1"
  shift 1

  # PowerPC CPU add-on
  case $arch in
    cpu-addon,*)
      cpu=` echo "$arch" | sed -n "/.*,\([^,]*\),.*$/s//\1/p"`
      arch=`echo "$arch" | sed -n "/.*,.*,\([^,]*\)$/s//\1/p"`
      ;;
    *)
      cpu=$arch
      ;;
  esac

  # Select optimization flags and compiler to use
  BuildAltArch="no"
  BuildCompFlags=""
  BuildFlags=""
  case $arch in
    i[3456]86 | athlon)
      BuildFlags="-march=$arch -mtune=generic"
      if [[ "`uname -m`" = "x86_64" ]]; then
        BuildAltArch="yes"
        BuildCompFlags="-m32"
      fi
      ;;
    x86_64)
      BuildFlags="-mtune=generic"
      ;;
    ppc)
      if [[ "`uname -m`" = "ppc64" ]]; then
        BuildAltArch="yes"
        BuildCompFlags="-m32"
        # 64-bit processors we support do support power4+ ISA (2.01)
        if [[ "$cpu" != "$arch" ]]; then
          BuildFlags="-mcpu=$cpu"
        else
          BuildFlags="-mcpu=power4 -mtune=cell"
        fi
      fi
      ;;
    ppc64)
      if [[ "$cpu" != "$arch" ]]; then
        BuildFlags="-mcpu=$cpu"
      else
        BuildFlags="-mcpu=power4 -mtune=cell"
      fi
      ;;
    alphaev6)
      BuildFlags="-mcpu=ev6"
      ;;
    sparc)
      BuildFlags="-fcall-used-g6"
      BuildCompFlags="-m32"
      ;;
    sparcv9)
      BuildFlags="-mcpu=ultrasparc -fcall-used-g6"
      BuildCompFlags="-m32"
      ;;
    sparc64)
      BuildFlags="-mcpu=ultrasparc -mvis -fcall-used-g6"
      BuildCompFlags="-m64 -mcpu=ultrasparc"
      ;;
    mips|mipsel)
      BuildFlags="-march=mips3"
      BuildCompFlags="-march=mips3"
      ;;
    mips32|mips32el)
      BuildFlags="-march=mips3 -mabi=n32"
      BuildCompFlags="-march=mips3 -mabi=n32"
      ;;
    mips64|mips64el)
      BuildFlags="-march=mips3 -mabi=64"
      BuildCompFlags="-march=mips3 -mabi=64"
      ;;
    armv4t*)
      BuildFlags="-march=armv4t"
      BuildCompFlags="-march=armv4t"
      ;;
    armv5t*)
      BuildFlags="-march=armv5t"
      BuildCompFlags="-march=armv5t"
      ;;
    # to check
    armv7*)
      BuildFlags="-march=armv7-a"
      BuildCompFlags="-march=armv7-a"
      ;;
  esac

  # Choose multiarch support
  MultiArchFlags=
  case $arch in
    i686 | x86_64)
      MultiArchFlags="--enable-multi-arch"
      ;;
  esac

  # Determine C & C++ compilers
  BuildCC="%{__cc} $BuildCompFlags"
  BuildCXX="%{__cxx} $BuildCompFlags"

  # Are we supposed to cross-compile?
  if [[ "%{target_cpu}" != "%{_target_cpu}" ]]; then
    # Can't use BuildCC anymore with previous changes.
    BuildCC="%{cross_program_prefix}gcc $BuildCompFlags"
    BuildCXX="%{cross_program_prefix}g++ $BuildCompFlags"
    BuildCross="--build=%{_target_platform}"
    export libc_cv_forced_unwind=yes libc_cv_c_cleanup=yes
  fi

  BuildFlags="$BuildFlags -DNDEBUG=1 -O2 -finline-functions -g"
  if $BuildCC -v 2>&1 | grep -q 'gcc version 3.0'; then
    # gcc3.0 had really poor inlining heuristics causing problems in
    # resulting ld.so
    BuildFlags="$BuildFlags -finline-limit=2000"
  fi

  # Do not use direct references against %gs when accessing tls data
  # XXX make it the default in GCC? (for other non glibc specific usage)
  case $arch in
    i[3456]86 | x86_64)
      BuildFlags="$BuildFlags -mno-tls-direct-seg-refs"
      ;;
  esac

  # Arch specific compilation flags
  if [[ "$arch" = "ppc64" ]]; then
    BuildFlags="$BuildFlags -fno-inline-functions -mno-minimal-toc"
  fi

  # Extra configure flags
  ExtraFlags=
  if [[ "%{build_profile}" != "0" ]]; then
    ExtraFlags="$ExtraFlags --enable-profile"
  fi

  # NPTL+TLS are now the default
  # check for other arches
  %if %isarch %ports_arch
    Pthreads="ports nptl"
  %else
    Pthreads="nptl"
  %endif
  TlsFlags="--with-tls --with-__thread"

  # Add-ons
  AddOns="$Pthreads,libidn"
  if [[ "$cpu" != "$arch" ]]; then
    AddOns="$AddOns,powerpc-cpu"
    BuildFlags="$BuildFlags -mcpu=$cpu"
    ExtraFlags="$ExtraFlags --with-cpu=$cpu"
  fi

  # Build with selinux support?
%if %{build_selinux}
  SElinuxFlags="--with-selinux"
%else
  SElinuxFlags="--without-selinux"
%endif

  # Kernel headers directory
  KernelHeaders=%{_includedir}

  # Determine library name
  glibc_cv_cc_64bit_output=no
  if echo ".text" | $BuildCC -c -o test.o -xassembler -; then
    case `/usr/bin/file test.o` in
    *"ELF 64"*)
      glibc_cv_cc_64bit_output=yes
      ;;
    esac
  fi
  rm -f test.o

  # Force a separate and clean object dir
  rm -rf build-$cpu-linux
  mkdir  build-$cpu-linux
  pushd  build-$cpu-linux
  [[ "$BuildAltArch" = "yes" ]] && touch ".alt" || touch ".main"
  CC="$BuildCC" CXX="$BuildCXX" CFLAGS="$BuildFlags" ../configure \
    $arch-%{_real_vendor}-linux%{gnuext} $BuildCross \
    --prefix=%{_prefix} \
    --libexecdir=%{_prefix}/libexec \
    --infodir=%{_infodir} \
    --enable-add-ons="$AddOns" --without-cvs \
    $TlsFlags $ExtraFlags $MultiArchFlags $SElinuxFlags \
    --enable-experimental-malloc \
    --enable-kernel=%{enablekernel} \
    --with-headers=$KernelHeaders ${1+"$@"}
  %make -r
  popd

  # All tests are expected to pass on certain platforms, depending also
  # on the version of the kernel running
  case $arch in
  athlon | ia64 | ppc | ppc64)
    if [ "`CompareKver %{check_min_kver}`" -lt 0 ]; then
      check_flags=""
    else
      check_flags="-k"
    fi
    ;;
  *)
    check_flags="-k"
    ;;
  esac

  # Generate test matrix
  [[ -d "build-$arch-linux" ]] || {
    echo "ERROR: PrepareGlibcTest: build-$arch-linux does not exist!"
    return 1
  }
  local BuildJobs="-j`getconf _NPROCESSORS_ONLN`"
  echo "$BuildJobs -d build-$arch-linux $check_flags" >> $CheckList

  case $cpu in
  i686|athlon)	base_arch=i586;;
  power*)	base_arch=$arch;;
  *)		base_arch=none;;
  esac

  [[ -d "build-$base_arch-linux" ]] && {
    check_flags="$check_flags -l build-$base_arch-linux/elf/ld.so"
    echo "$BuildJobs -d build-$arch-linux $check_flags" >> $CheckList
  }
  return 0
}

# Build main glibc
BuildGlibc %{target_cpu}

%if %{build_biarch}
%if %isarch sparc64
BuildGlibc sparcv9
%endif
%if %isarch x86_64
BuildGlibc i686
%endif
%if %isarch ppc64
BuildGlibc ppc
%endif
%endif
%if %isarch mips
BuildGlibc mips64
BuildGlibc mips32
%endif
%if %isarch mipsel
BuildGlibc mips64el
BuildGlibc mips32el
%endif
%if %isarch mips64
BuildGlibc mips
BuildGlibc mips32
%endif
%if %isarch mips64el
BuildGlibc mipsel
BuildGlibc mips32el
%endif

%if %isarch ppc ppc64
for cpu in %{powerpc_cpu_list}; do
  [[ "$cpu" = "noarch" ]] && continue
  BuildGlibc cpu-addon,$cpu,%{_arch} --disable-profile
done
%endif

# Build i686 libraries if not already building for i686/athlon
case %{target_cpu} in
  i686 | athlon)
    ;;
  i[3-6]86)
    BuildGlibc i686 --disable-profile
    ;;
esac

make -C crypt_blowfish-%{crypt_bf_ver} man

%if %{build_check}
export TMPDIR=/tmp
export TIMEOUTFACTOR=16
Check="$PWD/glibc-check.sh"
cat %{SOURCE5} > $Check
chmod +x $Check
while read arglist; do
  $Check $arglist || exit 1
done < $CheckList
%endif

%install
rm -rf $RPM_BUILD_ROOT

# force use of _NPROCESSORS_ONLN jobs since RPM_BUILD_NCPUS could be
# greater for icecream
BuildJobs="-j`getconf _NPROCESSORS_ONLN`"

make install_root=$RPM_BUILD_ROOT install -C build-%{target_cpu}-linux
%if %{build_i18ndata}
(cd build-%{target_cpu}-linux;
  make $BuildJobs -C ../localedata objdir=`pwd` \
	install_root=$RPM_BUILD_ROOT \
	install-locales
)
install -m 0644 localedata/SUPPORTED $RPM_BUILD_ROOT/%{_datadir}/i18n/
%endif
sh manpages/Script.sh

# Empty filelist for non i686/athlon targets
> extralibs.filelist

# Install biarch libraries
%if %{build_biarch} || %isarch mips mipsel
%if %isarch sparc64
ALT_ARCHES=sparcv9-linux
%endif
%if %isarch x86_64
ALT_ARCHES=i686-linux
%endif
%if %isarch ppc64
ALT_ARCHES=ppc-linux
%endif
%if %isarch mips
ALT_ARCHES="mips64-linux mips32-linux"
%endif
%if %isarch mipsel
ALT_ARCHES="mips64el-linux mips32el-linux"
%endif
%if %isarch mips64
ALT_ARCHES="mips-linux mips32-linux"
%endif
%if %isarch mips64el
ALT_ARCHES="mipsel-linux mips32el-linux"
%endif

for ALT_ARCH in $ALT_ARCHES; do
mkdir -p $RPM_BUILD_ROOT/$ALT_ARCH
make install_root=$RPM_BUILD_ROOT/$ALT_ARCH install -C build-$ALT_ARCH

# Dispatch */lib only
case "$ALT_ARCH" in
	mips32*)
		LIB="%{_slibdir}32"
		;;
	mips64*)
		LIB="%{_slibdir}64"
		;;
	*)
		LIB=/lib
		;;
esac
%if !%{build_cross}
mv     $RPM_BUILD_ROOT/$ALT_ARCH/$LIB $RPM_BUILD_ROOT/$LIB
rm -f  $RPM_BUILD_ROOT/$ALT_ARCH/%_prefix/lib/pt_chown
mv     $RPM_BUILD_ROOT/$ALT_ARCH%{_prefix}/libexec/getconf/* \
       $RPM_BUILD_ROOT%{_prefix}/libexec/getconf/
[ ! -d $RPM_BUILD_ROOT/%{_prefix}/$LIB/ ] && mkdir -p $RPM_BUILD_ROOT/%{_prefix}/$LIB/
mv     $RPM_BUILD_ROOT/$ALT_ARCH/%{_prefix}/$LIB/* $RPM_BUILD_ROOT/%{_prefix}/$LIB/
%else
mv     $RPM_BUILD_ROOT/$ALT_ARCH/%{_prefix}/lib $RPM_BUILD_ROOT/$LIB
rm -f  $RPM_BUILD_ROOT/%{_prefix}/libexec/pt_chown
rm -f  $RPM_BUILD_ROOT/$LIB/pt_chown
sed -i $RPM_BUILD_ROOT/$LIB/libc.so -e "s!%{_slibdir}!$LIB!g"
%endif

# We want 32-bit binaries on sparc64
%if %isarch sparc64
mv -f    $RPM_BUILD_ROOT/$ALT_ARCH/sbin/* $RPM_BUILD_ROOT/sbin
mv -f    $RPM_BUILD_ROOT/$ALT_ARCH/%{_bindir}/* $RPM_BUILD_ROOT%{_bindir}
mv -f    $RPM_BUILD_ROOT/$ALT_ARCH/%{_sbindir}/* $RPM_BUILD_ROOT%{_sbindir}
%endif
rm -rf $RPM_BUILD_ROOT/$ALT_ARCH
# XXX Dispatch 32-bit stubs
(sed '/^@/d' include/stubs-prologue.h; LC_ALL=C sort $(find build-$ALT_ARCH -name stubs)) \
> $RPM_BUILD_ROOT%{_includedir}/gnu/stubs-32.h
done
%endif
%if %{build_cross}
rm -f  $RPM_BUILD_ROOT/%{_prefix}/libexec/pt_chown
%endif

# Install extra glibc libraries
function InstallGlibc() {
  local BuildDir="$1"
  local SubDir="$2"
  local LibDir="$3"

  case $BuildDir in
  *)      Pthreads=nptl         ;;
  esac

  [[ -z "$LibDir" ]] && LibDir="%{_slibdir}"

  pushd $BuildDir
  mkdir -p $RPM_BUILD_ROOT$LibDir/$SubDir/
  install -m755 libc.so $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libc-*.so`
  ln -sf `basename $RPM_BUILD_ROOT$LibDir/libc-*.so` $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libc.so.*`
  install -m755 math/libm.so $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libm-*.so`
  ln -sf `basename $RPM_BUILD_ROOT$LibDir/libm-*.so` $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libm.so.*`
  install -m755 $Pthreads/libpthread.so $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libpthread-*.so`
  ln -sf `basename $RPM_BUILD_ROOT$LibDir/libpthread-*.so` $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libpthread.so.*`
  install -m755 ${Pthreads}_db/libthread_db.so $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libthread_db-*.so`
  ln -sf `basename $RPM_BUILD_ROOT$LibDir/libthread_db-*.so` $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libthread_db.so.*`
  install -m755 rt/librt.so $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/librt-*.so`
  ln -sf `basename $RPM_BUILD_ROOT$LibDir/librt-*.so` $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/librt.so.*`
  echo "%dir $LibDir/$SubDir" >> ../extralibs.filelist
  find $RPM_BUILD_ROOT$LibDir/$SubDir -maxdepth 1  -type f -o -type l | sed -e "s|$RPM_BUILD_ROOT||" >> ../extralibs.filelist
  popd
}

# Install arch-specific optimized libraries
%if %isarch %{ix86}
case %{target_cpu} in
i[3-5]86)
  InstallGlibc build-i686-linux i686
  ;;
esac
%endif
%if %isarch ppc ppc64
for cpu in %{powerpc_cpu_list}; do
  [[ "$cpu" = "noarch" ]] && continue
  InstallGlibc build-$cpu-linux $cpu
done
# Use hardlinks, not symlinks
# see upper NOTE if you really want dedicated power5+ hwcap...
[[ -d "$RPM_BUILD_ROOT/%{_lib}/power5" ]] && {
  mkdir -p $RPM_BUILD_ROOT/%{_lib}/power5+
  ln -v	$RPM_BUILD_ROOT/%{_lib}/power5/*.so \
	$RPM_BUILD_ROOT/%{_lib}/power5+/
  $RPM_BUILD_ROOT/sbin/ldconfig -n $RPM_BUILD_ROOT/%{_lib}/power5+/
  echo "%dir /%{_lib}/power5+" >> extralibs.filelist
  find $RPM_BUILD_ROOT$LibDir/%{_lib}/power5+/ -maxdepth 1  -type f -o -type l | sed -e "s|$RPM_BUILD_ROOT||" >> extralibs.filelist
}
%endif

# NPTL <bits/stdio-lock.h> is not usable outside of glibc, so include
# the generic one (RH#162634)
install -m644 bits/stdio-lock.h $RPM_BUILD_ROOT%{_includedir}/bits/stdio-lock.h

# Compatibility hack: this locale has vanished from glibc, but some other
# programs are still using it. Normally we would handle it in the %pre
# section but with glibc that is simply not an option
mkdir -p $RPM_BUILD_ROOT%{_datadir}/locale/ru_RU/LC_MESSAGES

# Remove the files we don't want to distribute
rm -f $RPM_BUILD_ROOT%{_libdir}/libNoVersion*
rm -f $RPM_BUILD_ROOT%{_slibdir}/libNoVersion*

ln -sf libbsd-compat.a $RPM_BUILD_ROOT%{_libdir}/libbsd.a
%if %{build_biarch}
ln -sf libbsd-compat.a $RPM_BUILD_ROOT%{_prefix}/lib/libbsd.a
%endif
%if %isarch mips mipsel
ln -sf libbsd-compat.a $RPM_BUILD_ROOT%{_libdir}32/libbsd.a
ln -sf libbsd-compat.a $RPM_BUILD_ROOT%{_libdir}64/libbsd.a
%endif

%if "%{name}" == "glibc"
install -m 644 mageia/nsswitch.conf $RPM_BUILD_ROOT%{_sysconfdir}/nsswitch.conf
%endif

# This is for ncsd - in glibc 2.2
%if %{build_nscd}
install -m 644 nscd/nscd.conf $RPM_BUILD_ROOT%{_sysconfdir}
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
install -m 755 nscd/nscd.init $RPM_BUILD_ROOT%{_initrddir}/nscd
%endif

# These man pages require special attention
mkdir -p %{buildroot}%{_mandir}/man3
install -p -m 0644 crypt_blowfish-%{crypt_bf_ver}/*.3 %{buildroot}%{_mandir}/man3/

# Useless and takes place
rm -rf %buildroot/%{_datadir}/zoneinfo/{posix,right}

# Include ld.so.conf
%if "%{name}" == "glibc"
%if %isarch mips mipsel
# needed to get a ldd which understands o32, n32, 64
install -m 755 $RPM_BUILD_DIR/%{source_dir}/build-mips64el-linux/elf/ldd $RPM_BUILD_ROOT/%{_bindir}/ldd
%endif
echo "include /etc/ld.so.conf.d/*.conf" > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf
chmod 644 $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf
mkdir -p  $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d

# ldconfig cache
mkdir -p $RPM_BUILD_ROOT%{_var}/cache/ldconfig
touch $RPM_BUILD_ROOT%{_var}/cache/ldconfig/aux-cache

# automatic ldconfig cache update on rpm installs/removals
# (see http://wiki.mandriva.com/en/Rpm_filetriggers)
install -d %buildroot%{_var}/lib/rpm/filetriggers
cat > %buildroot%{_var}/lib/rpm/filetriggers/ldconfig.filter << EOF
^.((/lib|/usr/lib)(32|64)?/[^/]*\.so\.|/etc/ld.so.conf.d/[^/]*\.conf)
EOF
cat > %buildroot%{_var}/lib/rpm/filetriggers/ldconfig.script << EOF
#!/bin/sh
ldconfig -X
EOF
chmod 755 %buildroot%{_var}/lib/rpm/filetriggers/ldconfig.script
%endif

# Include %{_libdir}/gconv/gconv-modules.cache
> $RPM_BUILD_ROOT%{_libdir}/gconv/gconv-modules.cache
chmod 644 $RPM_BUILD_ROOT%{_libdir}/gconv/gconv-modules.cache

%if "%{name}" == "glibc"
touch $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.cache
%endif

# Add libraries to debug sub-package
%if %{build_debug}
mkdir $RPM_BUILD_ROOT%{_libdir}/debug
#cp -a $RPM_BUILD_ROOT%{_libdir}/*.a $RPM_BUILD_ROOT%{_libdir}/debug/
#rm -f $RPM_BUILD_ROOT%{_libdir}/debug/*_p.a
cp -a $RPM_BUILD_ROOT%{_slibdir}/lib*.so* $RPM_BUILD_ROOT%{_libdir}/debug/

pushd $RPM_BUILD_ROOT%{_libdir}/debug
for lib in *.so*; do
  [[ -f "$lib" ]] && DEBUG_LIBS="$DEBUG_LIBS %{_libdir}/debug/$lib"
done
popd
%endif

# Are we cross-compiling?
Strip="strip"
if [[ "%{_target_cpu}" != "%{target_cpu}" ]]; then
  Strip="%{cross_program_prefix}$Strip"
fi

# Strip libpthread but keep some symbols
find $RPM_BUILD_ROOT%{_slibdir} -type f -name "libpthread-*.so" \
     -o -type f -name "libc-*.so" | \
     xargs $Strip -g -R .comment

%if %{build_biarch}
find $RPM_BUILD_ROOT/lib -type f -name "libpthread-*.so" \
     -o -type f -name "libc-*.so" | \
     xargs $Strip -g -R .comment
%endif

# Strip debugging info from all static libraries
pushd $RPM_BUILD_ROOT%{_slibdir}
for i in *.a; do
  if [ -f "$i" ]; then
    case "$i" in
    *_p.a) ;;
    *) $Strip -g -R .comment $i ;;
    esac
  fi
done
popd

# post install wrapper
%__cc -Os -DSLIBDIR="\"%{_slibdir}\"" -DASH_BIN="\"%{ash_bin}\"" %{SOURCE14} -static \
	-L $RPM_BUILD_ROOT%{_libdir}/ \
	-o $RPM_BUILD_ROOT%{_sbindir}/glibc-post-wrapper
chmod 700 $RPM_BUILD_ROOT%{_sbindir}/glibc-post-wrapper

# rquota.x and rquota.h are now provided by quota
rm -f $RPM_BUILD_ROOT%{_includedir}/rpcsvc/rquota.[hx]

# Hardlink identical locale files together
%if %{build_i18ndata}
gcc -O2 -o build-%{target_cpu}-linux/hardlink redhat/hardlink.c
build-%{target_cpu}-linux/hardlink -vc $RPM_BUILD_ROOT%{_datadir}/locale
%endif

rm -rf $RPM_BUILD_ROOT%{_includedir}/netatalk/

# Build file list for devel package
find $RPM_BUILD_ROOT%{_includedir} -type f -or -type l > devel.filelist
find $RPM_BUILD_ROOT%{_includedir} -type d  | sed "s/^/%dir /" | \
  grep -v "%{_libdir}/libnss1.*.so$" | \
  grep -v "%{_includedir}$" | >> devel.filelist
find $RPM_BUILD_ROOT%{_libdir} -maxdepth 1 -name "*.so" -o -name "*.o" | egrep -v "(libmemusage.so|libpcprofile.so)" >> devel.filelist
# biarch libs
%if %{build_biarch}
find $RPM_BUILD_ROOT%{_prefix}/lib -maxdepth 1 -name "*.so" -o -name "*.o" | egrep -v "(libmemusage.so|libpcprofile.so)" >> devel.filelist
%endif
%if %isarch mips mipsel
find $RPM_BUILD_ROOT%{_libdir}32 -maxdepth 1 -name "*.so" -o -name "*.o" | egrep -v "(libmemusage.so|libpcprofile.so)" >> devel.filelist
find $RPM_BUILD_ROOT%{_libdir}64 -maxdepth 1 -name "*.so" -o -name "*.o" | egrep -v "(libmemusage.so|libpcprofile.so)" >> devel.filelist
%endif
perl -pi -e "s|$RPM_BUILD_ROOT||" devel.filelist

# /etc/localtime - we're proud of our timezone #Well we may put Paris
%if %{build_timezone}
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/localtime
cp -f $RPM_BUILD_ROOT%{_datadir}/zoneinfo/US/Eastern $RPM_BUILD_ROOT%{_sysconfdir}/localtime
#ln -sf ..%{_datadir}/zoneinfo/US/Eastern $RPM_BUILD_ROOT%{_sysconfdir}/localtime
%endif

# [gg] build PDF documentation
%if %{build_pdf_doc}
(cd manual; texi2dvi -p -t @afourpaper -t @finalout libc.texinfo)
%endif

# the last bit: more documentation
rm -rf documentation
mkdir documentation
cp timezone/README documentation/README.timezone
cp ChangeLog* documentation
gzip -9 documentation/ChangeLog*
mkdir documentation/crypt_blowfish-%{crypt_bf_ver}
install -m 644 crypt_blowfish-%{crypt_bf_ver}/{README,LINKS,PERFORMANCE} \
	documentation/crypt_blowfish-%{crypt_bf_ver}

# Generate final rpm filelist, with localized libc.mo files
rm -f rpm.filelist
%if "%{name}" == "glibc"
%find_lang libc
perl -ne '/^\s*$/ or print' libc.lang > rpm.filelist
%endif
cat extralibs.filelist >> rpm.filelist

# Remove unpackaged files
rm -f  $RPM_BUILD_ROOT%{_infodir}/dir.old*
rm -rf $RPM_BUILD_ROOT%{_includedir}/asm-*/mach-*/
rm -f  $RPM_BUILD_ROOT%{_datadir}/locale/locale-archive*

%if !%{build_utils}
%if %{build_biarch}
rm -f  $RPM_BUILD_ROOT%{_slibdir32}/libmemusage.so
rm -f  $RPM_BUILD_ROOT%{_slibdir32}/libpcprofile.so
%endif
%if %isarch mips mipsel
rm -f  $RPM_BUILD_ROOT%{_slibdir}32/libmemusage.so
rm -f  $RPM_BUILD_ROOT%{_slibdir}32/libpcprofile.so
rm -f  $RPM_BUILD_ROOT%{_slibdir}64/libmemusage.so
rm -f  $RPM_BUILD_ROOT%{_slibdir}64/libpcprofile.so
%endif
rm -f  $RPM_BUILD_ROOT%{_slibdir}/libmemusage.so
rm -f  $RPM_BUILD_ROOT%{_slibdir}/libpcprofile.so
rm -f  $RPM_BUILD_ROOT%{_bindir}/memusage
rm -f  $RPM_BUILD_ROOT%{_bindir}/memusagestat
rm -f  $RPM_BUILD_ROOT%{_bindir}/mtrace
rm -f  $RPM_BUILD_ROOT%{_bindir}/pcprofiledump
rm -f  $RPM_BUILD_ROOT%{_bindir}/xtrace
%endif

%if !%{build_timezone}
rm -f  $RPM_BUILD_ROOT%{_sysconfdir}/localtime
rm -f  $RPM_BUILD_ROOT%{_sbindir}/zdump
rm -f  $RPM_BUILD_ROOT%{_sbindir}/zic
rm -f  $RPM_BUILD_ROOT%{_mandir}/man1/zdump.1*
rm -rf $RPM_BUILD_ROOT%{_datadir}/zoneinfo
%endif

%if !%{build_i18ndata}
rm -rf $RPM_BUILD_ROOT%{_datadir}/i18n
%endif

%if "%{name}" != "glibc"
rm -rf $RPM_BUILD_ROOT/boot
rm -rf $RPM_BUILD_ROOT/sbin
rm -rf $RPM_BUILD_ROOT/usr/share
rm -rf $RPM_BUILD_ROOT%{_bindir}
rm -rf $RPM_BUILD_ROOT%{_sbindir}
rm -rf $RPM_BUILD_ROOT%{_datadir}
rm -rf $RPM_BUILD_ROOT%{_mandir}
rm -rf $RPM_BUILD_ROOT%{_infodir}
rm -rf $RPM_BUILD_ROOT%{_prefix}/etc
rm -rf $RPM_BUILD_ROOT%{_libdir}/gconv
%endif

# In case we are cross-compiling, don't bother to remake symlinks and
# fool spec-helper when stripping files
%if "%{name}" != "glibc"
export DONT_SYMLINK_LIBS=1
export PATH=%{_bindir}:$PATH
%endif

EXCLUDE_FROM_STRIP="ld-%{glibcversion}.so libpthread libc-%{glibcversion}.so $DEBUG_LIBS"
export EXCLUDE_FROM_STRIP

%if "%{name}" == "glibc"
%define upgradestamp %{_slibdir}/glibc.upgraded
%define broken_link %{_slibdir}/libnss_nis.so.1 %{_slibdir}/libnss_files.so.1 %{_slibdir}/libnss_dns.so.1 %{_slibdir}/libnss_compat.so.1

%pre -p %{ash_bin}
# test(1) and echo(1) are built-ins
if [ -d %{_slibdir} ] && [ ! -f %{_slibdir}/libnss_files-%{glibcversion}.so ]; then
  echo > %{upgradestamp}
fi

%post -p %{_sbindir}/glibc-post-wrapper
export LC_ALL=C

if [ "$1" -gt 1 ]; then
  # migrate /etc/ld.so.conf to include the new /etc/ld.so.conf.d/
  # without external commands but for removing the temporary file
  ldso_conf=/etc/ld.so.conf
  while read i; do
    [ "$i" = "include /etc/ld.so.conf.d/*.conf" ] && keep=1
    # Remove previously used include line without absolute path
    [ "$i" = "include ld.so.conf.d/*.conf" ] || echo $i
  done < $ldso_conf > $ldso_conf-
  if [ -z "$keep" ]; then
    echo "include /etc/ld.so.conf.d/*.conf" > $ldso_conf
    while read i; do
      echo $i
    done < $ldso_conf- >> $ldso_conf
  fi
  [ -x /bin/rm ] && /bin/rm -f $ldso_conf-
fi
/sbin/ldconfig

if [ "$1" -gt 1 ]; then
  # On upgrade the services doesn't work because libnss couldn't be
  # loaded anymore.
  if [ -f %{upgradestamp} ]; then
    if /usr/bin/readlink /proc/1/exe >/dev/null && \
       /usr/bin/readlink /proc/1/root >/dev/null; then
       if [ -x /sbin/telinit -a -p /dev/initctl ]; then
         /sbin/telinit u
       fi
       if [ -x /etc/init.d/sshd -a \
            -x /usr/sbin/sshd -a \
            -x /bin/bash ]; then
         /etc/init.d/sshd condrestart
       fi
    fi
  fi
  if [ -f /bin/rm ]; then
    for i in %broken_link; do
      if [ -e $i ] && [ ! -L $i ]; then
        /bin/rm -f $i
      fi
    done
  fi
fi
[ -x /bin/rm ] && /bin/rm -f %{upgradestamp}

# always generate the gconv-modules.cache
%{_sbindir}/iconvconfig -o %{_libdir}/gconv/gconv-modules.cache --nostdlib %{_libdir}/gconv

%endif

%pre devel
if [ -L %{_includedir}/scsi ]; then
  rm -f %{_includedir}/scsi
fi
if [ -L %{_includedir}/sound ]; then
  rm -f %{_includedir}/sound
fi
if [ -L %{_includedir}/linux ]; then
  rm -f %{_includedir}/linux
fi
if [ -L %{_includedir}/asm ]; then
  rm -f %{_includedir}/asm
fi
if [ -L %{_includedir}/asm-generic ]; then
  rm -f %{_includedir}/asm-generic
fi
%if %isarch x86_64
if [ -L %{_includedir}/asm-x86_64 ]; then
  rm -f %{_includedir}/asm-x86_64
fi
if [ -L %{_includedir}/asm-i386 ]; then
  rm -f %{_includedir}/asm-i386
fi
%endif
%if %isarch ppc64
if [ -L %{_includedir}/asm-ppc64 ]; then
  rm -f %{_includedir}/asm-ppc64
fi
if [ -L %{_includedir}/asm-ppc ]; then
  rm -f %{_includedir}/asm-ppc
fi
%endif
%if %isarch sparc64
if [ -L %{_includedir}/asm-sparc64 ]; then
  rm -f %{_includedir}/asm-sparc64
fi
if [ -L %{_includedir}/asm-sparc ]; then
  rm -f %{_includedir}/asm-sparc
fi
%endif
%if %isarch %mips
if [ -L %{_includedir}/asm-mips ]; then
  rm -f %{_includedir}/asm-mips
fi
%endif
%if %isarch %arm
if [ -L %{_includedir}/asm-arm ]; then
  rm -f %{_includedir}/asm-arm
fi
%endif
exit 0

%if %{build_doc}
%post doc
%_install_info libc.info

%preun doc
%_remove_install_info libc.info
%endif

%if %{build_nscd}
%pre -n nscd
%_pre_useradd nscd / /bin/false

%post -n nscd
%_post_service nscd

%preun -n nscd
%_preun_service nscd

%postun -n nscd
%_postun_userdel nscd

if [ "$1" -ge "1" ]; then
  /sbin/service nscd condrestart > /dev/null 2>&1 || :
fi
%endif

%clean
#rm -rf "$RPM_BUILD_ROOT"
#rm -f *.filelist*

#
# glibc
#
%files -f rpm.filelist
%defattr(-,root,root)
%if "%{name}" == "glibc"
%if %{build_timezone}
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/localtime
%endif
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/nsswitch.conf
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/ld.so.conf
%dir %{_sysconfdir}/ld.so.conf.d
%config(noreplace) %{_sysconfdir}/rpc
%doc nis/nss
%doc posix/gai.conf
%{_mandir}/man1/*
%{_mandir}/man8/rpcinfo.8*
%{_mandir}/man8/ld.so*
%{_datadir}/locale/locale.alias
/sbin/sln
%dir %{_prefix}/libexec/getconf
%{_prefix}/libexec/getconf/*
%endif
%{_slibdir}/ld-%{glibcversion}.so
%if %isarch i386 alpha sparc sparc64
%{_slibdir}/ld-linux.so.2
%endif
%if %isarch %arm
%{_slibdir}/ld-linux.so.3
%endif
%if %isarch ppc
%{_slibdir}/ld.so.1
%endif
%if %isarch ppc64
%{_slibdir}/ld64.so.1
%endif
%if %isarch ia64
%{_slibdir}/ld-linux-ia64.so.2
%endif
%if %isarch x86_64
%{_slibdir}/ld-linux-x86-64.so.2
%endif
%if %isarch m68k
%{_slibdir}/ld.so.1
%endif
%if %isarch %mips
%{_slibdir}/ld.so.1
%endif
%{_slibdir}/lib*-[.0-9]*.so
%{_slibdir}/lib*.so.[0-9]*
%{_slibdir}/libSegFault.so
%if "%{name}" == "glibc"
%dir %{_libdir}/gconv
%{_libdir}/gconv/*.so
%{_libdir}/gconv/gconv-modules
%ghost %{_libdir}/gconv/gconv-modules.cache
%attr(4755,root,root) %{_prefix}/libexec/pt_chown
%{_bindir}/catchsegv
%{_bindir}/gencat
%{_bindir}/getconf
%{_bindir}/getent
#%{_bindir}/glibcbug
%{_bindir}/iconv
%{_bindir}/ldd
%if %isarch i386 ppc sparc sparc64
%{_bindir}/lddlibc4
%endif
%{_bindir}/locale
%{_bindir}/localedef
%{_bindir}/rpcgen
%{_bindir}/sprof
%{_bindir}/tzselect
%{_sbindir}/rpcinfo
%{_sbindir}/iconvconfig
%{_sbindir}/glibc-post-wrapper
%endif

%if %{build_biarch}
%{_slibdir32}/ld-%{glibcversion}.so
%if %isarch ppc64
%{_slibdir32}/ld.so.1
%else
%{_slibdir32}/ld-linux*.so.2
%endif
%{_slibdir32}/lib*-[.0-9]*.so
%{_slibdir32}/lib*.so.[0-9]*
%{_slibdir32}/libSegFault.so
%dir %{_prefix}/lib/gconv
%{_prefix}/lib/gconv/*
%endif
%if %isarch mips mipsel
%{_slibdir}32/ld-%{glibcversion}.so
%{_slibdir}32/ld.so.1
%{_slibdir}32/lib*-[.0-9]*.so
%{_slibdir}32/lib*.so.[0-9]*
%{_slibdir}32/libSegFault.so
%dir %{_libdir}32/gconv
%{_libdir}32/gconv/*
%{_slibdir}64/ld-%{glibcversion}.so
%{_slibdir}64/ld.so.1
%{_slibdir}64/lib*-[.0-9]*.so
%{_slibdir}64/lib*.so.[0-9]*
%{_slibdir}64/libSegFault.so
%dir %{_libdir}64/gconv
%{_libdir}64/gconv/*
%endif

#
# ldconfig
#
%if "%{name}" == "glibc"
%defattr(-,root,root)
/sbin/ldconfig
%{_mandir}/man8/ldconfig*
%ghost %{_sysconfdir}/ld.so.cache
%dir %{_var}/cache/ldconfig
%ghost %{_var}/cache/ldconfig/aux-cache
%{_var}/lib/rpm/filetriggers/ldconfig.*
%endif

#
# glibc-devel
#
%files devel -f devel.filelist
%defattr(-,root,root)
%doc README NEWS INSTALL FAQ BUGS NOTES PROJECTS CONFORMANCE
%doc COPYING COPYING.LIB
%doc documentation/* README.libm
%doc hesiod/README.hesiod
%doc crypt/README.ufc-crypt
%if "%{name}" == "glibc"
%{_mandir}/man3/*
%endif
%{_libdir}/libbsd-compat.a
%{_libdir}/libbsd.a
%{_libdir}/libc_nonshared.a
%{_libdir}/libg.a
%{_libdir}/libieee.a
%{_libdir}/libmcheck.a
%{_libdir}/libpthread_nonshared.a
%if "%{name}" == "glibc"
%{_libdir}/librpcsvc.a
%endif
%if %isarch ppc ppc64 sparc
%{_libdir}/libnldbl_nonshared.a
%endif

%if %{build_biarch}
%{_prefix}/lib/libbsd-compat.a
%{_prefix}/lib/libbsd.a
%{_prefix}/lib/libc_nonshared.a
%{_prefix}/lib/libg.a
%{_prefix}/lib/libieee.a
%{_prefix}/lib/libmcheck.a
%{_prefix}/lib/libpthread_nonshared.a
%{_prefix}/lib/librpcsvc.a
%if %isarch ppc64 sparc64
%{_prefix}/lib/libnldbl_nonshared.a
%endif
%endif

%if %isarch mips mipsel
%{_libdir}32/libbsd-compat.a
%{_libdir}32/libbsd.a
%{_libdir}32/libc_nonshared.a
%{_libdir}32/libg.a
%{_libdir}32/libieee.a
%{_libdir}32/libmcheck.a
%{_libdir}32/libpthread_nonshared.a
%if "%{name}" == "glibc"
%{_libdir}32/librpcsvc.a
%endif
%{_libdir}64/libbsd-compat.a
%{_libdir}64/libbsd.a
%{_libdir}64/libc_nonshared.a
%{_libdir}64/libg.a
%{_libdir}64/libieee.a
%{_libdir}64/libmcheck.a
%{_libdir}64/libpthread_nonshared.a
%if "%{name}" == "glibc"
%{_libdir}64/librpcsvc.a
%endif
%endif

#
# glibc-static-devel
#
%files static-devel
%defattr(-,root,root)
%doc COPYING COPYING.LIB
%{_libdir}/libBrokenLocale.a
%{_libdir}/libanl.a
%{_libdir}/libc.a
%{_libdir}/libcrypt.a
%{_libdir}/libdl.a
%{_libdir}/libm.a
%{_libdir}/libnsl.a
%{_libdir}/libpthread.a
%{_libdir}/libresolv.a
%{_libdir}/librt.a
%{_libdir}/libutil.a

%if %{build_biarch}
%{_prefix}/lib/libBrokenLocale.a
%{_prefix}/lib/libanl.a
%{_prefix}/lib/libc.a
%{_prefix}/lib/libcrypt.a
%{_prefix}/lib/libdl.a
%{_prefix}/lib/libm.a
%{_prefix}/lib/libnsl.a
%{_prefix}/lib/libpthread.a
%{_prefix}/lib/libresolv.a
%{_prefix}/lib/librt.a
%{_prefix}/lib/libutil.a
%endif

%if %isarch mips mipsel
%{_libdir}32/libBrokenLocale.a
%{_libdir}32/libanl.a
%{_libdir}32/libc.a
%{_libdir}32/libcrypt.a
%{_libdir}32/libdl.a
%{_libdir}32/libm.a
%{_libdir}32/libnsl.a
%{_libdir}32/libpthread.a
%{_libdir}32/libresolv.a
%{_libdir}32/librt.a
%{_libdir}32/libutil.a

%{_libdir}64/libBrokenLocale.a
%{_libdir}64/libanl.a
%{_libdir}64/libc.a
%{_libdir}64/libcrypt.a
%{_libdir}64/libdl.a
%{_libdir}64/libm.a
%{_libdir}64/libnsl.a
%{_libdir}64/libpthread.a
%{_libdir}64/libresolv.a
%{_libdir}64/librt.a
%{_libdir}64/libutil.a
%endif

#
# glibc-doc
#
%if %{build_doc}
%files doc
%defattr(-,root,root)
%{_infodir}/libc.info*
%endif

#
# glibc-doc-pdf
#
%if %{build_pdf_doc}
%files doc-pdf
%defattr(-,root,root)
%doc manual/libc.pdf
%endif

#
# glibc-debug
#
%if %{build_debug}
%files debug
%defattr(-,root,root)
%dir %{_libdir}/debug
%{_libdir}/debug/*.so
%{_libdir}/debug/*.so.*
%if %isarch mips mipsel
%dir %{_libdir}/debug/lib32
%{_libdir}/debug/lib32/*.so
%{_libdir}/debug/lib32/*.so.*
%dir %{_libdir}/debug/lib64
%{_libdir}/debug/lib64/*.so
%{_libdir}/debug/lib64/*.so.*
%endif
%endif

#
# glibc-profile
#
%if %{build_profile}
%files profile
%defattr(-,root,root)
%{_libdir}/lib*_p.a
%if %{build_biarch}
%{_prefix}/lib/lib*_p.a
%endif
%if %isarch mips mipsel
%{_libdir}32/lib*_p.a
%{_libdir}64/lib*_p.a
%endif
%endif

#
# glibc-utils
#
%if %{build_utils}
%files utils
%defattr(-,root,root)
%if %{build_biarch}
%{_slibdir32}/libmemusage.so
%{_slibdir32}/libpcprofile.so
%endif
%{_slibdir}/libmemusage.so
%{_slibdir}/libpcprofile.so
%{_bindir}/memusage
%{_bindir}/memusagestat
%{_bindir}/mtrace
%{_bindir}/pcprofiledump
%{_bindir}/xtrace
%if %isarch mips mipsel
%{_slibdir}32/libmemusage.so
%{_slibdir}32/libpcprofile.so
%{_slibdir}64/libmemusage.so
%{_slibdir}64/libpcprofile.so
%endif
%endif

#
# nscd
#
%if %{build_nscd}
%files -n nscd
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/nscd.conf
%config(noreplace) %{_initrddir}/nscd
%{_sbindir}/nscd
%endif

#
# timezone
#
%if %{build_timezone}
%files -n timezone
%defattr(-,root,root)
%{_sbindir}/zdump
%{_sbindir}/zic
%{_mandir}/man1/zdump.1*
%dir %{_datadir}/zoneinfo
%{_datadir}/zoneinfo/*
%endif

#
# glibc-i18ndata
#
%if %{build_i18ndata}
%files i18ndata
%defattr(-,root,root)
%dir %{_datadir}/i18n
%dir %{_datadir}/i18n/charmaps
%{_datadir}/i18n/charmaps/*
%dir %{_datadir}/i18n/locales
%{_datadir}/i18n/locales/*
%{_datadir}/i18n/SUPPORTED
%endif






%changelog

* Tue Jan 24 2012 tmb <tmb> 6:2.12.1-11.3.mga1
+ Revision: 200632
- fix Integer overflow DoS in posix/fnmatch.c (CVE-2011-1659)
- fix locale.c output to prevent local users to gain elevated privilegies
  (CVE-2011-1095)
- fix denial of service (memory consumption) via a long UTF8 string that
  is used in an fnmatch call (CVE-2011-1071)
- Report write error in addmnt even for cached streams (CVE-2011-1089)
- revert: "Fix potential removal of required local scope from shared
  objects marked as NODELETE (patch from opensuse, mga #2526)" as it
  introduces regressions
- Fix potential removal of required local scope from shared objects
  marked as NODELETE (patch from opensuse, mga #2526)
- Fix handling of tail bytes of buffer in SSE2/SSSE3 x86-64 version strncmp
- Fix alignment of AVX safe area on x86-64 (BZ #12113, mga #1362)
  (fixes java crashes on x86_64 hw supporting AVX)
- crypt_blowfish: fix 8-bit character handling vulnerability (CVE-2011-2483)

  + rtp <rtp>
    - remove native pt_chown when generating cross glibc for non-biarch/mips* case
      too
    - fix cross_program_prefix
    - move gnuext macro for build_cross case after isarch definition
    - doesn't create a ld.so.cache in build_cross case

* Tue Mar 22 2011 rtp <rtp> 6:2.12.1-11.mga1
+ Revision: 75374
- Add support for glibc-ports
- Add arm support
- Add early mips support
- Attempt to fix cross glibc generation

* Thu Feb 24 2011 misc <misc> 6:2.12.1-10.mga1
+ Revision: 58741
- rebuilt for removing various Conflicts and Obsoletes
- remove timezone links that are already present in upstream glibc
- do not hardcode our distro name
- clean old Obsoletes
- remove various Conflicts that are no longer relevant ( like on kernel 2.0.. )
- remove old conflict on rpm < 4.2.2 that date back to 5 years ago

* Mon Jan 10 2011 dmorgan <dmorgan> 6:2.12.1-9.mga1
+ Revision: 5255
- Rediff glibc-2.3.6-nsswitch.conf.patch

  + blino <blino>
    - add back wrongly removed endif
    - remove old comment
    - remove old ldconfig scriptlets

  + tmb <tmb>
    - imported package glibc


* Thu Jan 06 2011 Thomas Backlund <tmb@mageia.org> 6:2.12.1-9.mga1
- initial import
- drop rpm tags
- drop mandriva specific changes

* Mon Dec 27 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.12.1-8mnb2
+ Revision: 625383
- Fix _PATH_VI for Mandriva also in sysdeps/unix/sysv/linux/paths.h
  (MDV #60929).

* Tue Nov 23 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.12.1-7mnb2
+ Revision: 600264
- Include getlogin_r fixes from glibc head (MDV #61145).

* Sun Oct 24 2010 Oden Eriksson <oeriksson@mandriva.com> 6:2.12.1-6mnb2
+ Revision: 587863
- P45: security fix for CVE-2010-3856 (redhat)

* Wed Oct 20 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.12.1-5mnb2
+ Revision: 586990
- Add fix for CVE-2010-3847
  (http://sourceware.org/ml/libc-hacker/2010-10/msg00007.html)

* Sat Oct 16 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.12.1-4mnb2
+ Revision: 585932
- Add patch from Andreas Schwab, posted on libc-hacker, that fixes
  another make 3.82 issue in glibc, detected by tst-xmmymm failure
  (http://sources.redhat.com/ml/libc-hacker/2010-09/msg00001.html)

* Wed Sep 29 2010 Anssi Hannula <anssi@mandriva.org> 6:2.12.1-3mnb2
+ Revision: 582103
- fix regression of ldconfig -r when /var/cache/ldconfig does not exist
  inside the chroot and running as non-root (as used by e.g. icecream)
  (upstream bug #11149, patch by Petr Baudis)

* Tue Sep 28 2010 Anssi Hannula <anssi@mandriva.org> 6:2.12.1-2mnb2
+ Revision: 581834
- fix build of locales package by adding transliteration for U20A1
  (COLON SIGN) (patch by Aurelien Jarno from Debian tree as spotted by
  Thomas Backlund)

* Fri Aug 27 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.12.1-0.1mnb2
+ Revision: 573446
- Updated to version 2.12.1
- Fix build with make 3.82
- Rediffed assign-global-scope-to-RFC-1918-addresses patch
- Include nss config file template for /etc/default in documentation
- Dropped merged/obsolete patches:
  glibc-2.11-Prevent-silent-errors-should-x86-64-strncmp-be-neede.patch
  glibc-2.11-Avoid-ELF-lookup-race.patch
  glibc-2.11-Fix-malloc_info-without-prioor-allocations.patch
  glibc-2.11-Pass-sysdep-LDFLAGS-when-using-print-file-name.patch
  glibc-2.11-_nl_load_locale-incorrectly-handles-mmap-failures.patch
  glibc-2.11-sysdeps-ieee754-ldbl-128-fixes.patch
  glibc-2.11-Don-t-map-U00DF-to-U1E9E-in-toupper-table.patch
  glibc-2.11-check-fd-arg-in-futimens.patch
  glibc-2.11-Add-nonnull-attribute-to-unsetenv-declaration.patch
  glibc-2.11-Additional-setcontext-etc.-conformance-tests.patch
  glibc-2.11-Make-unistd.h-pre-c-safe.patch
  glibc-2.6.1-CVE-2010-0296.diff
  glibc-2.11-Remove-unnecessary-returns.patch
  glibc-2.11-Always-use-IPv4-sockets-for-IPv4-addresses.patch
  glibc-2.11-Fix-error-checking-in-iconv.patch
  glibc-2.11-Redefine-O_SYNC-and-O_DSYNC-to-match-2.6.33-kernels.patch
  glibc-2.11-regcomp.c-do-not-ignore-memory-allocation-failure.patch
  glibc-2.6.1-CVE-2010-0015.diff
  glibc-2.11-Use-struct-timespec-for-timestamps-in-struct-stat-al.patch
  glibc-2.11-Remove-duplicate-definitions-of-O_DSYNC-and-O_RSYNC.patch
  glibc-2.11-Fix-typo-in-feature-selection-macro-use.patch
  glibc-2.11-Fix-file-descriotor-leak-in-nftw-with-FTW_CHDIR.patch
  glibc-2.11-Try-harder-to-re-exec-nscd-in-paranoia-mode.patch
  glibc-2.11-assign-global-scope-to-RFC-1918-addresses.patch
  glibc-2.11-Fix-a-few-more-cases-of-ignored-return-values-in-reg.patch
  glibc-2.11-Fix-endless-loop-with-invalid-etc-shells-file.patch
  glibc-2.11-Follow-kernel-F_OWNER_-GID-PGRP-change.patch
  glibc-2.11-Define-IPTOS_CLASS_-macros-according-to-RFC-2474.patch
  glibc-2.11-Use-correct-type-when-casting-d_tag.patch
  glibc-2.11-Invalid-timeouts-in-i386-sem_timedwait.patch
  glibc-2.11-more-re-fixes.patch
  glibc-2.11-Define-SCHED_IDLE-and-SCHED_RESET_ON_FORK-for-Linux.patch
  glibc-2.11-Fix-sorting-of-malayalam-letter-na.patch
  glibc-2.11-Update-constants-for-current-kernels.patch
  glibc-2.11-Ignore-negative-dynamic-entry-types.patch
  glibc-2.11-Avoid-alloca-in-setenv-for-long-strings.patch
  glibc-2.11-Update-poll.h-header-for-POSIX-2008.patch

* Tue Jun 08 2010 Oden Eriksson <oeriksson@mandriva.com> 6:2.11.1-8mnb2
+ Revision: 547264
- P95: security fix for CVE-2010-0015
- P96: security fix for CVE-2010-0296

* Mon May 31 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11.1-7mnb2
+ Revision: 546806
- Fix permission of /usr/share/doc/glibc-devel/crypt_blowfish-1.0.2/*
  files (#59585).

* Fri May 14 2010 Eugeni Dodonov <eugeni@mandriva.com> 6:2.11.1-6mnb2
+ Revision: 544813
- Bump release.

  + Herton Ronaldo Krzesinski <herton@mandriva.com.br>
    - Revert removal of exclusion list to avoid stripping of some of glibc
      libraries and loader (#59247).
    - Removal of more unwanted patch backup files shipped in created packages.

* Tue Apr 27 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11.1-4mnb2
+ Revision: 539689
- Rebuild with rpm-mandriva-setup-build >= 1.104, with fixed stripping
  of shared libraries (reported/requested by Christophe Fergeau).

* Mon Apr 19 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11.1-3mnb2
+ Revision: 536772
- Assign global scope to RFC 1918 addresses in getaddrinfo (MDV #58834).

* Thu Apr 08 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11.1-2mnb2
+ Revision: 533159
- Fix localedef --add-to-archive with locales which have symlinked
  common files to optimize disk space usage.

* Wed Mar 31 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11.1-1mnb2
+ Revision: 530536
- Updated to glibc 2.11.1, dropped merged patches:
  glibc-2.11-restore-locking-in-free_check.patch
  glibc-2.11-Add-missing-Linux-MADV_-definitions.patch
  glibc-2.11-Fix-getwc-and-putwc-on-non-wide-streams.patch
  glibc-2.11-Avoid-warnings-in-CPU_-macros-when-using-const-bitsets.patch
  glibc-2.11-Fix-startup-to-security-relevant-static-binaries.patch
  glibc-2.11-Fix-F_SETOWN_EX-and-F_GETOWN_EX-definitions.patch
  glibc-2.11-Fix-spelling-in-memusagestat.c.patch
  glibc-2.11-Fix-week-information-for-nl_NL-locale.patch
  glibc-2.11-Properly-handle-STT_GNU_IFUNC-symbols-in-do_sym.patch
  glibc-2.11-Prevent-unintended-file-desriptor-leak-in-grantpt.patch
  glibc-2.11-Handle-running-out-of-buffer-space-with-IPv6-mapping.patch
  glibc-2.11-Fixes-for-bz10968-bz10969.patch
  glibc-2.11-Reinitialize-_create_xid-state-after-fork.patch
  glibc-2.11-Define-week-first_weekday-and-first_workday-for-en_DK.patch
  glibc-2.11-Define-week-first_weekday-and-first_workday-for-hsb_DE.patch
  glibc-2.10.1-fix-preadv-pwritev-fallocate-__off_t.patch
  glibc-2.11-Fix-ranges-with-multibyte-characters-as-endpoints.patch
  glibc-2.11-Fix-infloop-in-__pthread_disable_asynccancel-on-x86_64.patch

* Fri Mar 05 2010 Per Øyvind Karlsen <peroyvind@mandriva.org> 6:2.11-2mnb2
+ Revision: 514736
- fix #57754 at the source in rpm-mandriva-setup-build & spec-helper in stead
- don't strip away symbols needed for ie. valgrind (fixes #57754)

  + Herton Ronaldo Krzesinski <herton@mandriva.com.br>
    - Apply fixes/additions from glibc git master in glibc 2.11 for
      following upstream tickets: bz11126, bz11120, bz11200, bz10992,
      bz11115, bz11194, bz11141, bz11127, bz11271, bz11242, bz11027,
      bz11183, bz11184, bz11185, bz11186, bz11187, bz11188, bz11189,
      bz11190, bz11191, bz11192, bz11193, bz10414, bz11235, bz11093.
    - Apply following fixes from glibc git master:
      * Avoid ELF lookup race
      * Pass $(sysdep-LDFLAGS) when using --print-file-name
      * sysdeps/ieee754/ldbl-128/ fixes
      * Don't map U00DF to U1E9E in toupper table
      * Add nonnull attribute to unsetenv declaration
      * Make unistd.h pre-c99-safe
      * Fix error checking in iconv
      * Redefine O_SYNC and O_DSYNC to match 2.6.33+ kernels
      * Remove duplicate definitions of O_DSYNC and O_RSYNC for Linux/sparc
      * Fix typo in feature selection macro use
      * Fix a few more cases of ignored return values in regex
      * Use correct type when casting d_tag
      * Invalid timeouts in i386 sem_timedwait
      * Simplify test in re_string_skip_chars
      * Ignore negative dynamic entry types
      * Avoid alloca in setenv for long strings

* Thu Dec 03 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11-1mnb2
+ Revision: 472873
- Added conflicts for old prelink versions that brakes the system with
  glibc 2.11
- Added fix for bz10851, patch from upstream bugzilla.
- Apply upstream fixes/testcases after glibc 2.11, consisting in the
  following patches:
  glibc-2.11-Properly-handle-STT_GNU_IFUNC-symbols-in-do_sym.patch
  glibc-2.11-Fix-spelling-in-memusagestat.c.patch
  glibc-2.11-Handle-running-out-of-buffer-space-with-IPv6-mapping.patch
  glibc-2.11-Fix-F_SETOWN_EX-and-F_GETOWN_EX-definitions.patch
  glibc-2.11-Add-missing-Linux-MADV_-definitions.patch
  glibc-2.11-Fixes-for-bz10968-bz10969.patch
  glibc-2.11-Fix-ranges-with-multibyte-characters-as-endpoints.patch
  glibc-2.11-Follow-kernel-F_OWNER_-GID-PGRP-change.patch
  glibc-2.11-Avoid-warnings-in-CPU_-macros-when-using-const-bitsets.patch
  glibc-2.11-Fix-getwc-and-putwc-on-non-wide-streams.patch
  glibc-2.11-Reinitialize-_create_xid-state-after-fork.patch
  glibc-2.11-Fix-week-information-for-nl_NL-locale.patch
  glibc-2.11-Try-harder-to-re-exec-nscd-in-paranoia-mode.patch
  glibc-2.11-Use-struct-timespec-for-timestamps-in-struct-stat-al.patch
  glibc-2.11-Define-week-first_weekday-and-first_workday-for-en_DK.patch
  glibc-2.11-Define-week-first_weekday-and-first_workday-for-hsb_DE.patch
  glibc-2.11-Fix-startup-to-security-relevant-static-binaries.patch
  glibc-2.11-Prevent-unintended-file-desriptor-leak-in-grantpt.patch
  glibc-2.11-Fix-infloop-in-__pthread_disable_asynccancel-on-x86_64.patch
  glibc-2.11-Define-SCHED_IDLE-and-SCHED_RESET_ON_FORK-for-Linux.patch
- Enable experimental-malloc, and replace mdv51545 patch by "Restore
  locking in free_check" upstream fix.
- Enable multi-arch for i686 and x86_64.
- Enable verbose build for checking.
- Do not build with -U_FORTIFY_SOURCE
- kernel-headers was renamed to linux-userspace-headers, update
  BuildRequires/Requires.
- Use /usr/libexec as libexec directory.
- Add BuildRequires for libcap-devel
- Updated to 2.11
  * dropped merged patches:
    glibc-2.10-branch.patch
    glibc-2.10.1-branch-revert-fix-permission-slave-dev-on-devpts.patch
  * dropped libidn tarballs, libidn is now included in main glibc 2.11
  * provide againt pt_chown after grantpt/pt_chown changes in 2.11, also
    allow libcap to be used without selinux.

* Tue Nov 17 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-8mnb2
+ Revision: 467050
- Ship SUPPORTED localedata file with glibc-i18ndata

* Mon Nov 09 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-7mnb2
+ Revision: 463354
- Apply "Fix preadv, pwritev and fallocate for -D_FILE_OFFSET_BITS=64"
  change from glibc upstream.

* Fri Oct 09 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-6mnb2
+ Revision: 456468
- glibc-manpages.tar.bz2: remove tzselect man page, it's outdated, newer
  versions are provided by man-pages* packages (#20326).

  + Pascal Terjan <pterjan@mandriva.org>
    - Fix service name for mysql (Guillaume Rousse)

* Fri Jul 31 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-5mnb2
+ Revision: 405246
- Mandriva does not ship pt_chown with glibc, not supporting system
  without devpts. After glibc 2.10.1 we will must ship it again with
  suid because of grantpt changes upstream, but for now just revert the
  grantpt commit cherry pick from upstream changes with bug fixes in
  glibc-2.10-branch.patch (patch with pull from Petr Baudis repository
  at git://repo.or.cz/glibc/pb-stable.git glibc-2.10-branch).
- Updated glibc-2.10-branch.patch, and drop i386-futex-typo patch merged
  at it.

* Thu Jun 25 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 6:2.10.1-4mnb2
+ Revision: 389221
- add a versioned buildrequires on spec-helper just to be on the safe side :)
- with the mystery of the missing debug symbols solved in spec-helper 0.30.5,
  rebuild to really solve this one (closes #51374)

* Tue Jun 23 2009 Pascal Terjan <pterjan@mandriva.org> 6:2.10.1-3mnb2
+ Revision: 388677
- Rebuild to hopefuly get -debug

* Thu Jun 11 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-2mnb2
+ Revision: 385040
- Fixed free_check locking issue (#51545).
- Fixed typo in i386 version of LOAD_FUTEX_WAIT_ABS macro.
- Updated glibc 2.10.1 branch patch (glibc-2.10-branch.patch).

* Wed May 27 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-1mnb2
+ Revision: 380201
- Updated to version 2.10.1
- Dropped merged patches:
  glibc-2.9-bz7067.patch
  glibc-2.9-bz9741.patch
  glibc-2.9-fedora_upstream_fixes.patch
  glibc-2.9-expm1-error.patch
  glibc-2.9-bz6545.patch
  glibc-2.9-bz9750.patch
  glibc-2.9-bz9694.patch
  glibc-2.9-en_GB-first-week-work-day.patch
  glibc-2.9-newer-link-scripts-insert-_begin.patch
  glibc-2.9-SHM_EXEC.patch
  glibc-2.9-dup2_avoid_access_through_PLT.patch
  glibc-2.9-bz7056.patch
  glibc-2.9-_nss_dns_gethostbyaddr2_r-buffer-aligment.patch
  glibc-2.9-bug-hsearch1.patch
  glibc-2.9-bz7040.patch
- Include patch with pull from "git://repo.or.cz/glibc/pb-stable.git
  glibc-2.10-branch", glibc 2.10.1 branch provided by Petr Baudis from
  Suse (http://sources.redhat.com/ml/libc-alpha/2009-05/msg00117.html)
- Rediffed patches: mdv-avx-owl-crypt, mdv-owl-crypt_freesec, multiarch,
  biarch-cpp-defines
- Drop glibc-2.9-dns-no-gethostbyname4.patch, newer glibc has handling
  now to workaround IPv4-IPv6 parallel lookup problems with broken DNS
  servers.

* Mon Apr 06 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.9-0.20081113.5mnb2
+ Revision: 364483
- Fix first_weekday/first_workday for en_GB locale (#49506).

* Mon Apr 06 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.9-0.20081113.4mnb2
+ Revision: 364480
- Conflict with fileutils < 4.3.5 to avoid problems when upgrading
  (#49589).

* Thu Mar 26 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.9-0.20081113.3mnb2
+ Revision: 361466
- Added fixes from glibc cvs for:
  * upstream glibc bz7056 (closes also mdv bug #49142).
  * build issue with binutils 2.19.51.0.2, reference:
    http://sourceware.org/bugzilla/show_bug.cgi?id=9843

* Fri Feb 06 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.9-0.20081113.2mnb2
+ Revision: 338006
- Add fixes from glibc cvs that deals with following upstream tickets:
  bz7067, bz9741, bz6545, bz9750, bz9694, bz7040. Also another
  miscellaneous fixes included (patches expm1-error, SHM_EXEC,
  _nss_dns_gethostbyaddr2_r-buffer-aligment bug-hsearch1).
- Avoid backup file created with patch glibc-2.9-fedora_upstream_fixes.patch to
  end up in glibc-i18ndata package.

* Mon Jan 19 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.9-0.20081113.1mnb2
+ Revision: 331180
- Additional fix on top of fedora_upstream_fixes added from glibc cvs to
  avoid local plt check error (make check).
- Removed some uneeded old patches.
- Update glibc to version 2.9 (20081113).
- Unfuzz following patches:
  glibc-2.9-ldd-non-exec.patch
  glibc-2.9-share-locale.patch
  glibc-2.2.5-nscd-no-host-cache.patch
  glibc-2.7-mdv-owl-crypt_freesec.patch
  glibc-2.3.5-avx-relocate_fcrypt.patch
- Remove uneeded patch glibc-2.1.95-string2-pointer-arith.patch, there is no
  need to force cast to char * for point arithmetic, as explicitely the gcc
  extension for void * pointer arithmetic is being used.
- Removed patches already applied:
  glibc-2.3.2-config-amd64-alias.patch
  glibc-nscd_fixes.patch
  glibc-2.8-tst-iconv-fixes.patch
- Apply 'hot fixes' from fedora/upstream and workaround for glibc bz7060

* Fri Aug 29 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.8-1.20080520.5mnb2
+ Revision: 277480
- Handle properly upgrades from ld.so.conf with relative ld.so.conf.d
  include path after previous commit.

  + Helio Chissini de Castro <helio@mandriva.com>
    - Lack of relative path on ld.so.conf is breaking usage of ldconfig -r. Reviewed by Herton

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - handle libraries in non-standard locations with ld.so.conf config in /etc/ld.so.conf.d/
    - fix file trigger filter match for lib64

* Wed Jul 02 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.8-1.20080520.4mnb2
+ Revision: 230820
- Add more should start entries for nscd init service, reported by
  Guillaume Rousse (#41055).
- Added more upstream nscd fixes.
- Add upstream change that replaces
  glibc-2.8-bug-iconv6_tst-iconv7-localedata.patch (one of bug-iconv6
  and tst-iconv7 fixes). I didn't saw that there were already a change
  that fixed the same issue.

  + Vincent Danen <vdanen@mandriva.com>
    - properly use conditionals for build_i18ndata and build_timezone so recent rpm doesn't complain
    - update the wrapper_handle_sha patch to fully handle sha256c and sha512c; this makes sha256c viable with passwd (although sha512c still needs some work)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Thu Jun 05 2008 Pixel <pixel@mandriva.com> 6:2.8-1.20080520.3mnb2
+ Revision: 215279
- add rpm filetrigger running "ldconfig -X" when rpm install/remove libraries
- drop patch5 since ldconfig is now nicely handled using rpm filetrigger

* Mon May 26 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.8-1.20080520.2mnb2
+ Revision: 211410
- Add bug-iconv6 and tst-iconv7 fixes from glibc cvs. Even with them
  tests would fail: localedata isn't processed before iconvdata, so
  de_DE.UTF-8 isn't available for the tests. Probably this wasn't
  catched as this problem is masked if de_DE.UTF-8 is already installed
  on main system. Made a patch to make iconvdata depend on localedata.
- nscd init service should start ldap service if present (mdv bug
  41055).
- Remove patches not needed anymore for glibc tests related to gcc 4.2
- Cleanup mdkversion uses from spec: there is no reason for backporting
  or using current package on older distro releases.
- Use different numbering scheme in package release for this glibc 2.8
  "stable-snapshot" release, discussed on Cooker mailing list (asked by
  Anssi Hannula, Thierry Vignaud).
- Remove uneeded README.upgrade.urpmi message since addition of Provides
  to "should-restart = system".
- Rediffed ENOTTY-fr-translation patch.

* Wed May 21 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.8-1mnb2
+ Revision: 209635
- Disable temporarily make check for x86_64.
- Update to glibc 2.8 (no official tarball, generated one from
  glibc-2_8-branch glibc cvs branch).
- Drop glibc cvs patches already applied.
- Merge glibc-2.3.4-nscd-fixes.patch and glibc-2.6-nscd_HUP.patch into
  glibc-nscd_fixes.patch and added more updates/fixes from RedHat.
- Removed update for perl 5.10 (mtrace-perl-5.10.0 patch), already
  applied.

* Tue May 06 2008 Vincent Danen <vdanen@mandriva.com> 6:2.7-13mnb2
+ Revision: 201765
- bump release
- imported crypt-blowfish support from Annvix (2.6.1-8123avx):
  - added crypt-blowfish 1.0.2
  - added crypt_freesec.[ch] source files
  - crypt_freesec.patch which addes support for extended/new-style/BSDI hashes in crypt(3)
  - relocate_fcrypt.patch relocates the fcrypt definition from crypt-entry.c to crypt_blowfish's wrapper.c to enable gcc4 builds
  - increase_BF_FRAME.pach increases the BF_FRAME and BF_CLEAN values
  - crypt.patch is the crypt_blowfish patch for glibc 2.4 (rediffed from the crypt_blowfish package)
  - packages provide glibc-crypt_blowfish
- rediffed crypt.patch
- rediffed crypt_freesec.patch
- added wrapper_handle_sha.patch to add sha256-crypt and sha512-crypt support to the Openwall wrapper.c file, otherwise sha(256|512)-crypt support won't work

* Thu Mar 20 2008 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> 6:2.7-12mnb1
+ Revision: 189119
- use %%_real_vendor macro instead of mandriva as rpmscripts directory name.

* Wed Mar 12 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-11mnb1
+ Revision: 187259
- Disable again make check failure for i[3456]8: failure happens on
  build system but not locally here, and 32 bits on x86_64 fails too
  because missing 32 libs (fixable later with BuildRequires etc.).
- Revert again change that causes java programs use too much memory on
  x86_64 (#38830).
- Workaround test-double failure on x86 with gcc 4.2, found out by
  Makoto Dei (#38794). Also reenable make check failure for i[3456]8.

* Mon Mar 10 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-10mnb1
+ Revision: 183209
- Added cacheinfo update for Intel Tolapai and fix for bz5541 from glibc
  cvs.

  + Anssi Hannula <anssi@mandriva.org>
    - add comments regarding _(provides|requires)_exceptions

* Tue Mar 04 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-9mnb1
+ Revision: 178439
- Provides should be used for previous change (not Suggests), reported
  by Anssi Hannula.

* Mon Mar 03 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-8mnb1
+ Revision: 178073
- Added "Suggests: should-restart = system" to main glibc package,
  proposed by Frederic Crozat (see "RFC: add support in packages for
  notifying user about system reboot needed (or service restart needed)"
  message on cooker ML).

* Wed Feb 27 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-7mnb1
+ Revision: 175818
- Require dash-static instead of dash, because dash requires glibc and
  introduces dependency problems (reported by Pascal Rigaux - pixel).

* Tue Feb 26 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-6mnb1
+ Revision: 175412
- Added fixes from glibc cvs: bz5465, fix-tzh_version-check,
  i486-memmove-with-fortify-fix, x86_64-memset-add-missing-sfence,
  bz5439, bz5441, bz5346.

  + Pixel <pixel@mandriva.com>
    - replace %%mkrel with %%manbo_mkrel for Manbo Core 1

* Sun Feb 10 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-5mdv2008.1
+ Revision: 164745
- Rebuild glibc with kernel-headers-2.6.24-2mdv2008.1

* Fri Feb 08 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-4mdv2008.1
+ Revision: 164302
- Removed kernel-headers, now provided by a standalone package.

* Fri Feb 08 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-3mdv2008.1
+ Revision: 164149
- Prepare to remove kernel-headers from glibc-devel package (removed
  provides, obsoletes and header files, to be able to insert separated
  kernel-headers package on distro).

* Fri Feb 01 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-2mdv2008.1
+ Revision: 161195
- Added patch to avoid $* deprecated warning when using perl 5.10.0 with
  mtrace.
- Updated kernel-headers to version 2.6.24.1mdv
- Added manual fixes from glibc cvs (glibc-2.7-manual_update.patch).
  Removed glibc-2.6-texi_buildpdf_fix.patch, as this obsoletes it.
- Added fixes for bz5222 and bz5600 from glibc cvs.

* Fri Jan 04 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-1mdv2008.1
+ Revision: 144915
- Updated to version 2.7
- Updated kernel-headers to version 2.6.24-0.rc6.3mdv
- Removed glibc-2.4.90-powerpc-no-clock_gettime-vdso.patch, seems to be
  not needed anymore.
- Added patch from upstream cvs to fix i586 build
  (glibc-2.7-memcpy_chk_i586.patch).
- Removed already applied patches in glibc 2.7:
  glibc-2.5-ldconfig-old-cache.diff
  glibc-cvs-nscd_dont_cache_ttl0.patch
  glibc-cvs-utimensat.patch
  glibc-bz4599.patch
  glibc-bz4125.patch
  glibc-cvs-gcc_init_fini.patch
  glibc-bz4647.patch
  glibc-bz4773.patch
  glibc-_nl_explode_name_segfault_fix.patch
  glibc-bz4776.patch
  glibc-bz4775.patch
  glibc-cvs-popen_bug_fix.patch
  glibc-bz4792.patch
  glibc-cvs-_cs_posix_v6_width_restricted_envs.patch
  glibc-bz4813.patch
  glibc-bz4812.patch
  glibc-bz4772.patch
  glibc-cvs-warning_patrol_fixes.patch
  glibc-cvs-getconf_add_missing_lvl4_cache_linesize.patch
  glibc-cvs-libc_texinfo_update.patch
  glibc-cvs-ix86_rwlock_fixes.patch
  glibc-cvs-gettext_memleak_fixes.patch
  glibc-cvs-strtod_handle_minuszero.patch
  glibc-cvs-ar_SA-dz_BT-LC_TIME-fixes.patch
  glibc-cvs-po_updates.patch
  glibc-cvs-rh250492.patch
- Removed already applied kernel-headers-dvb-video-fix-includes.patch in
  kernel headers.
- Fix test-ldouble with gcc 4.2 on x86. test-double still fails though,
  so disable make check failure for i[3456]8; it passes on x86_64, not
  sure if it's related to gcc 4.2, will need a better check later and
  someone that knows better about complex math.
- Rebuild with new lzma to fix permissions of man pages (#36176).

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Oct 31 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6.1-5mdv2008.1
+ Revision: 104208
- gconv-modules.cache is volatile (always changed by iconvconfig on
  post), mark it as ghost in rpm files section, so it's ignored in rpm
  -V output.
- Fix installation of lib{memusage,pcprofile}.so files (#35178). Don't
  move them around anymore and hack xtrace/memusage, just use upstream
  defaults avoiding troubles like this in the future.

* Thu Sep 27 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6.1-4mdv2008.0
+ Revision: 93205
- Revert pl_PL LC_TIME changes from glibc 2.6, it's causing problems for
  polish users, see http://qa.mandriva.com/show_bug.cgi?id=34134

* Fri Aug 31 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6.1-3mdv2008.0
+ Revision: 76895
- Rebuild for fixed package changelog.

* Mon Aug 27 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6.1-2mdv2008.0
+ Revision: 72022
- Added ldconfig cache speed up patch (added upstream, reported by
  Pascal Rigaux).
- Make package own ld.so.cache.
- Added pt_BR-i18nfixes patch, minor translation fixes for
  pt_BR, see patch for credits.
- Provide gai.conf sample.

  + Thierry Vignaud <tv@mandriva.org>
    - buildrequires obsoletes buildprereq

* Wed Aug 08 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6.1-1mdv2008.0
+ Revision: 60011
- Updated to version 2.6.1 (technically with previously added patches we
  were already there, this is more a cosmetic change).
- Removed patches already applied in 2.6.1: x86_64-memcpy_cacheinfo,
  epoll, nscd_get_mapping_crash_fix, sparc_build_fix,
  provide_CFI_for_the_outermost_function (reverted apply),
  i386_sync_file_range, bz4745, branch_misc_fixes, malloc,
  x86_64_dummy_files_prevent_stub, bz4512, bz4514,
  ld_hwcap_mask_handling_fix, bz4858, pthread_getattr_np_fix,
  tst_shm_fstat64, ldbl128ibm_fixes, bz4702.
- Added the following upstream fixes: rh250492, strtod_handle_minuszero,
  libc_texinfo_update, ar_SA-dz_BT-LC_TIME-fixes, po_updates,
  gettext_memleak_fixes, ix86_rwlock_fixes.
- Updated warning_patrol_fixes patch with more fixes.
- Really enable libidn addon.

* Mon Aug 06 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6-6mdv2008.0
+ Revision: 59528
- Added patch texi_buildpdf_fix, to fix build when build_pdf_doc is
  enabled (parse error fixes for texi2dvi).
- Re-enabled glibc-doc-pdf again (it was fixed in tetex 3.0-23mdk), from
  Giuseppe Ghib?\195?\178 <ghibo@mandriva.com>.

  + Anssi Hannula <anssi@mandriva.org>
    - Really apply kernel-headers-dvb-video-fix-includes.patch.

* Thu Aug 02 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6-5mdv2008.0
+ Revision: 58194
- Updated kernel-headers to version 2.6.22.3mdv. The only change inside
  it is to add pci_ids.h file, needed by ldetect as reported by Thierry
  Vignaud.

* Mon Jul 30 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6-4mdv2008.0
+ Revision: 56752
- Fixed missing header on popen_bug_fix patch.
- Added one more fix that went upstream related to
  _nl_explode_name_segfault_fix patch.
- Updated nscd_HUP patch from fedora.
- Added more fixes/additions that went upstream: bz4813, bz4772,
  warning_patrol_fixes, sparc_build_fix, bz4812, bz4792, bz4858,
  _cs_posix_v6_width_restricted_envs,
  getconf_add_missing_lvl4_cache_linesize.

* Wed Jul 25 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6-3mdv2008.0
+ Revision: 55382
- As reported and found out by Anssi Hannula, revert the following
  upstream change:
  2006-11-30  Jan Kratochvil  <jan.kratochvil@redhat.com>
  	* sysdeps/unix/sysv/linux/i386/clone.S: Provide CFI for the
  	* outermost
  	`clone' function to ensure proper unwinding stop of gdb.
  	* sysdeps/unix/sysv/linux/x86_64/clone.S: Likewise.
  It is causing memory leaks with gcj 4.3 on some cases on x86_64, and
  probably other problems, may be because of a binutils bug.
- Added fix for a popen bug from glibc cvs.

* Fri Jul 20 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6-2mdv2008.0
+ Revision: 53918
- Added patch from Anssi Hannula to fix a kernel header issue
  (kernel-headers-dvb-video-fix-includes.patch).
- Added missing fixes to ldbl128ibm_fixes patch.
- Removed hunk from kernel-headers-gnu-extensions.patch that patched
  linux/byteorder/swab.h, as code changed and isn't needed anymore (no
  need now for __extension__ as code no more uses "({ ... })" gcc
  extension).
- Updated kernel-headers to version 2.6.22.1mdv.
- Replaced init_tls_calls with more complete branch_misc_fixes patch,
  that includes it along with more fixes from upstream glibc 2.6 branch.
- Added upstream fix bz4775.
- Don't use echo on post, instead use README.upgrade.urpmi because of
  rpmdrake, as reported by Anssi Hannula. Also use better warning
  message.
- Removed glibc-post-upgrade, dont't restart all services on update
  (#21730). Only re-exec init and sshd if possible/needed.

  + Ademar de Souza Reis Jr <ademar@mandriva.com.br>
    - remove unecessary 'xset fp=[...]' from %%post, since xfs is not
      used anymore (besides, it was pointing to the wrong location)

* Fri Jul 13 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.6-1mdv2008.0
+ Revision: 51838
- Only allow make check to fail if current running kernel version is
  known to work.
- Added more fixes from Jakub Jelinek (upstream):
  _nl_explode_name_segfault_fix, bz4776.
- Deal with LD_LIBRARY_PATH bug when building package between major
  glibc versions.
- Added upstream fixes: nscd_get_mapping_crash_fix, bz4599,
  gcc_init_fini, i386_sync_file_range, init_tls_calls, bz4745, bz4647,
  x86_64_dummy_files_prevent_stub, ld_hwcap_mask_handling_fix,
  bz4773, pthread_getattr_np_fix, tst_shm_fstat64, ldbl128ibm_fixes,
  bz4125, bz4702, nscd_dont_cache_ttl0, utimensat, bz4586.
- Replaced amd64-string patch with x86_64-memcpy_cacheinfo that went
  upstream.
- Replaced futex-waiters with bz4512 patch (only test cases added).
- Replaced printf diff with glibc-bz4514.patch.
- Use new gcc 4.2 -mtune=generic flags for BuildFlags on x86/x86_64.
- Updated kernel headers (2.6.21.2mdv). Because of this removed/modified
  the following patches:
  * avx-kernel-headers-audit_support: already applied.
  * kernel-headers-include-2.6.17.1mdk, syscall-mem-clobbers: obsolete,
    not needed anymore.
  * gnu-extensions: modified, one hunk is not applying anymore as the
    file it patches is gone.
  This new kernel headers use the new scheme of sanitized upstream
  kernel headers, the tarball is generated from make
  headers_install_all.
- Updated create_asm_headers.sh script for new kernel headers.
- Added upstream/redhat patches printf, malloc, futex-waiters, epoll.
  Fix bugs/incompatibility issues in glibc 2.6 (the diffs are from
  suse).
- Updated to version 2.6.
- Redid patches that were not applying anymore: nscd_HUP, nice_fix,
  multiarch, new-charsets.
- Drop patches already applied: hwcap-check-platform, brazil-daylight,
  slovenia-euro, unicode5, all bz* patches, powerpc-ldbl-fixes,
  powerpc-hwcaps, fix-nptl-testcases, powerpc-regdump,
  ttyname-dont-use-isatty, fix-ppc32-setcontext,
  fix-pthread_mutex_timedlock.
- Disabled amd64 patches new-libm, amd64-fix-ceil, amd64-string: don't
  apply anymore, are not approved upstream yet, no updated version.

  + Andreas Hasenack <andreas@mandriva.com>
    - added audit patch, from Vdanen, so we can build audit

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - merge ldconfig package with glibc package
    - replace file dependency /sbin/install-info with package dependency info-install
    - s/mandrake/mandriva/
    - do not build and install localedata for $ALT_ARCH too (fixes #27214)
    - drop libnldbl_nonshared.a from sparc64 (fixes #30589)
    - fix reckless usage of s/.bz2// that broke patch names

  + Pixel <pixel@mandriva.com>
    - explicit file provide /sbin/ldconfig


* Wed Mar 07 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.4-8mdv2007.1
+ Revision: 134573
- split timezone package off glibc
- fix pthread_mutex_timedlock() on x86_64
- fix setcontext on ppc32
- fix floor() and ceil() inlines on i386 (BZ#3451)
- fix cross-compilation and packaging

* Thu Jan 18 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 6:2.4-7mdv2007.1
+ Revision: 110379
- add Unicode 5.0 support (Pablo)
- use Euro in Slovenia
- enable DT_GNU_HASH support only for MDK >= 2007.1
- explicitly optimize for Cell on powerpc

* Fri Jan 12 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 6:2.4-6mdv2007.1
+ Revision: 108082
- backport DT_GNU_HASH support
- sparc64 updates (Peroyvind)
- fix lsb T.ttyname_r (Stew, glibc head)

* Tue Oct 24 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.4-5mdv
- update Brazil tzdata (andreas, #26570)
- update powerpc-cpu add-on to 0.03
- reintroduce dl-cache AT_PLATFORM check from glibc 2.2.5
- really don't use -frename-registers (workaround rpmb bug)
- add selected fixes from 2.5-branch:
  * fix ppc{32,64} libSegFault.so register dump
  * fix 2 NPTL testcases
  * fix ppc{32,64} longjmp (BZ#3225)
  * use AT_PLATFORM and limit the number of important hwcaps on ppc
  * fix ppc{32,64} lrintl/lroundl
  * fix lrint on ppc32 (BZ#3155)
  * fix lrint, llrint (BZ#2592)
  * fix pthread_create() called from cancellation handlers (BZ#3124)
  * fix pthread_cond_{,timed}wait() cancellation (BZ#3123)
  * fix invalid free in error(3) (BZ#2998)
  * fix printing of hexadecimal floating point numbers (BZ#2908)
  * fix too large key check in pthread_setspecific (BZ#2892)
  * fix pthread_join() in already cancelled thread (BZ#2843)
  * fix UINT8_C and UINT16_C definitions in <stdint.h> (BZ#2841)
  * fix mktime() on 32-bit platforms for dates > 2038 (BZ#2821)
  * fix uninitialized len for alloca in ld.so $ORIGIN/$PLATFORM handling (BZ#2792)
  * fix malloc(0xFFFFnnnn) corruption from 32-bit wraparound (BZ#2775)
  * fix insque() to conform to POSIX (BZ#2766)
  * fix envz_strip() (BZ#2703)
  * fix dladdr() with SHN_UNDEF symbols (BZ#2683)
  * provide getlogin prototype even for -D_XOPEN_SOURCE=500 (BZ#2680)
  * fix cacosh() (BZ#2182)

* Mon Jul 24 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.4-4mdk
- update kernel headers to 2.6.17
- --enable-kernel=2.6.12 on powerpc arches
- add powerpc-cpu add-on and optimize for power5 and power6
- install generic <bits/stdio-lock.h> header (RH #162634)
- cleanups (use new %%isarch)
- sparc changes from Per Oyvind Karlsen
- buildrequires: texinfo (Christiaan Welvaart)
- build glibc-post-wrapper against newly installed libs (Christiaan)

* Mon May 22 2006 Arnaud Patard <apatard@mandriva.com> 2.4-3mdk
- update kernel-headers to the 2.6.16-2mdk to be able to build applications
  that are including linux/input.h

* Fri May 19 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.4-2mdk
- update new-charsets patch
- update kernel-headers to 2.6.16
- update x86_64 strings library from AMD

* Thu May 11 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.4-1mdk
- update to glibc 2.4 + CVS (2006/05/11) minus 2.5-specific bits
- drop linuxthreads for now, nptl is the default
- update x86_64 math library from AMD

* Mon Mar 20 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.6-3mdk
- refactor nsswitch.conf
- fix ENOTTY fr translation (noticed by Rafael)
- fix build on sparc32 (Per Oyvind, from Debian)
- fix nftw with root directory and FTW_CHDIR (#9121)
- fix dlopen() memory leaks (#21691, BZ #2451, from CVS HEAD)

* Mon Feb 20 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.6-2mdk
- all tests pass on ppc64
- fix localedef for complex LC_COLLATE rules (BZ #368, HEAD)
- make -mno-tls-direct-seg-refs the default for x86 Xen arches
- don't ship ppc64 asm headers for ppc32 builds
- don't provide ld-linux.so.2 on ppc (Christiaan Welvaart)

* Thu Feb 16 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.6-1mdk
- 2.3.6
- kernel-headers fixes (ppc64, ethtool.h, rsbac_syscall4)
- use dedicated macros to handle nscd service (FredL)
- fix permissions for */lib/*.so
- fix glibc-devel deps (#19145)
- fix upgrades from conectiva, aka conflicts glibc-base <= 2.3.4 (#19256)

* Wed Oct 19 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-6mdk
- support kernel 2.6 series only on ppc64
- add missing ppc64 asm headers for newer kernels

* Mon Aug 29 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-5mdk
- update to 2.6.12-11mdk kernel headers
- make glibc-utils scripts biarch capable
- ship with localised libc.mo files again
- ship with 32-bit profile libs on biarch platforms
- move Xen optimized libraries to their own subpackage
- check for /lib* prior to writing the upgrade stamp (G. Niemeyer)
- fix BZ #1188 (Sergio Gelato, mountd crash)

* Sat Aug 06 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-4mdk
- enable fortify with our gcc4
- fix amd64 string routines (latest snapshot from SuSE)
- provide nptl libraries suitable when running under Xen
- drop build support with distcc, icecream is used instead
- run testsuite with _NPROCESSORS_ONLN jobs at most (i.e. local run)

* Tue Aug 02 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-3mdk
- fix requires for shiny new rpm... and its bugs
- update to 2.6.12-8mdk kernel headers
- support only 2.6+ kernel series on ppc64
- minimal NPTL kernel for 2006 is >= 2.6.9, this brings the following:
  * getdents syscall returns d_type information as well
  * ppc adds signal/swapcontext support for VMX instructions & regstate
  * x86 has a fixed version of posix_fadvise64
  * new syscalls: waitid, utimes, tgkill, statfs64
- updates from 2.3-branch (2005/07/21):
  * avoid dynamically sized stack arrays in regex (BZ #1101)
  * fix sign-extension issues in xdr_stdio on 64-bit big endian
    machines + xdr{,_u}_hyper fixes (BZ #1098, #1097)
  * fix ISO-4217 spec for sr_CS locale, aka add CSD currency (BZ #549)
  * correctly account for characters of decimal points right after +-,
    aka scanf fixes (BZ #1110)
  * fix recursive dlclose (BZ #1081)
  * add %%z format to strptime (BZ #1105)
  * fix age calculation in nscd cache pruning (BZ #1094)
  * fix segfault in regexec (BZ #934)
  * fix posix_fallocate semantics using ftruncate (BZ #1083)
  * fix BZs #1099, #1108, #1100, #1103, #1095, #1101, #779, #1087,

* Wed Jun 15 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-2mdk
- generate gconv-modules.cache
- requires and post scripts tweaks
- add optimized AMD64 strings library
- fix tst-cancel17 with newer kernels (CVS HEAD)

* Fri Jun 03 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-1mdk
- factor out test matrix
- build 32-bit tls libs on x86_64
- build tls libraries on sparc64 (Stefan)
- remove -fno-unit-at-a-time from build flags
- fix aliasing in AMD64 new libm
- updates from 2.3-branch (2005/04/27):
  * update from Intel ia64 libm 2005-03-21
  * fix BZs #253, #776, #821, #822, #825, #851, #877

* Wed Mar 16 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-8mdk
- fix initstate_r (#14591)

* Thu Mar 10 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-7mdk
- fix package url (MDK #14468, Zeb)
- update to 2.6.11-2mdk kernel headers (inotify 0.20)
- update to stable 2.3-branch (2005/03/01):
  * fix BZs #284, #671, #719, #722, #726, #727, #729, #730, #731,
      * fix segfault in open_path, aka fix rsync --daemon (BZ #738)
  * fix powerpc64 set/swap context (BZ #700)
  * support -mno-tls-direct-seg-refs builds (BZ #737)
  * update to tz{code,data}2005c (BZ #736)
  * do not allocate potentially large buffers on the stack
  * futimes() should not fail with ENOENT (BZ #633)
  * declare ftruncate for POSIX 2003 (BZ #640)
  * fix rint on powerpc (BZ #602)
  * update ia64 libm (BZ #592)
  * fix round() to round return value to nearest (BZ #626)
  * fix {,q}ecvt{,_r} on denormals (BZ #725)
  * fix i386 stack alignment in clone and linuxthreads (BZ #723)

* Wed Feb 23 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-6mdk
- fix fdim() in x86_64 libm, use glibc implementation
- really stick with getconf files in /usr/lib/getconf
- update kernel headers to 2.6.10-3mdk for new inotify
- kernel header fixes (cdp, fddi)

* Thu Feb 10 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-5mdk
- kernel headers fixes (christiaan/ppc, directfb/x86_64, usbutils/any)

* Thu Jan 27 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-4mdk
- add missing getconf files
- always propagate pgoff_t definition (workaround kernel header)

* Mon Jan 24 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-3mdk
- relax __le64 and __be64 definitions in kernel headers

* Fri Jan 21 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-2mdk
- update to 2.6.10 kernel headers
- add memory clobbers in asm-i386 syscalls as arguments may be
  pointers to modifiable memory and values need to be reloaded
  (e.g. _llseek() in util-linux)

* Tue Dec 28 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-1mdk
- 2.3.4
- fix kernel headers (videodev2.h, blkpg.h on ppc64)
- bring "compat" only to nsswitch.conf
- cosmetics to make check machinery

* Thu Nov 25 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-23mdk
- fix cross bootstrap builds
- enable biarch support on ppc64
- enable tls and nptl on ia64 and ppc64

* Fri Oct 08 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-22mdk
- revert nsswitch.conf change
- fix <linux/ijxuser.h> on non x86 platforms
- reread /etc/localtime even if just mtime has changed (CVS)

* Thu Sep 16 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-21mdk
- add pcc to nptl arches
- fix path to nscd socket
- bring "compat" mode to nsswitch.conf
- fix kernel headers for usbutils rebuild

* Thu Sep 02 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-20mdk
- add ppc to tls arches (Christiaan Welvaart)
- selected fixes from CVS (2004/09/01):
  * fix locking issues in nscd
  * fix some IPv6 related bugs

* Wed Aug 25 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-19mdk
- fix nice
- fix nscd runlevels
- selected fixes from CVS (2004/08/24):
  * add O_NOATIME to linux <fcntl.h> from 2.6.8+ (BZ #341)
  * fix nis nss_compat's initgroups handling
  * fix possible problem with ld.so and brk management (BZ #227)

* Wed Aug 18 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-18mdk
- add missing glibc compat symlinks
- add sparc to TLS arches (Per Oyvind)
- fix <linux/capi.h> standalone inclusion

* Tue Aug 17 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-17mdk
- enable AMD optimized libm for x86_64
- add pow10 and friends in x86_64 libm

* Fri Aug 13 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-16mdk
- some minor build arrangements
- add compat glibc 2.0 for some ancient programs

* Fri Aug 13 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-15mdk
- fix <linux/crc-ccitt.h>
- update from CVS (2004/08/12):
  * fix BZ #150, #198, #217, #218, #219, #230, #231, #232, #262, #263
  * fix pthread_rwlock_timedrdlock on x86_64
  * fix values for -m32 -D_FILE_OFFSET_BITS=64 on x86_64
  * fix psignal() changes from previous CVS syncs
  * fix backtrace in statically linked programs on ia64/x86-64/s390{,x}
  * fix possible buffer overflow in crypt()
  * fix lowmem handling in chroot_canon() (BZ #199)
  * handle more than 6 args correctly on x86_64 makecontext()

* Wed Aug 11 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-14mdk
- update to 2.6.8 kernel headers (fix #10693)
- selected fixes from CVS:
  * make inet_pton() RFC2133 (BZ #295)
  * fix strtold() on 32-bit arches with ldbl-96 (BZ #274)
  * fix pow{,f,l}() on IA-32 and powl() on AMD64 (BZ #258)

* Mon Jul 05 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-13mdk
- fix upgrades for /etc/ld.so.conf.d/*
- update to 2.3.4 CVS snapshot (2004/06/01)
- update to 2.6.6+ kernel headers, I want POSIX message queues
- update patch to handle multiple types of libraries from one ld.so

* Tue May 25 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-12mdk
- Make ldconfig handle "include ld.so.conf.d/*.conf" (2.3.4-cvs)

* Thu Apr 15 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-11mdk
- Enable use of kernel timers for NPTL timer_create()
- Fix mathinline.h again
- alpha & sparc64 updates (Stefan)
- Merge from AMD64 branch:
  * Fix rwlocks on AMD64 with NPTL
  * Various fixes to kernel-headers
  * Really fix build on AMD64 with 2.4 kernel

